\echo ###### Prepare for the test
\set QUIET
SET client_min_messages = 'error';
CREATE EXTENSION IF NOT EXISTS pg_store_plans;
DROP TABLE IF EXISTS plans;
CREATE TABLE plans (id int, title text, lplan text, splan text);
SET client_min_messages = 'notice';
\set ECHO none

\echo ###### insert original JSON plans
INSERT INTO plans (VALUES
(-1, '###### Plan -1: all properties 1/2',
 '{
  "Plan": 0,
  "Plans": 0,
  "Node Type": "Result",
  "Node Type": "ModifyTable",
  "Node Type": "Append",
  "Node Type": "Merge Append",
  "Node Type": "Recursive Union",
  "Node Type": "BitmapAnd",
  "Node Type": "BitmapOr",
  "Node Type": "Seq Scan",
  "Node Type": "Index Scan",
  "Node Type": "Index Only Scan",
  "Node Type": "Bitmap Index Scan",
  "Node Type": "Bitmap Heap Scan",
  "Node Type": "Tid Scan",
  "Node Type": "Subquery Scan",
  "Node Type": "Function Scan",
  "Node Type": "Values Scan",
  "Node Type": "CTE Scan",
  "Node Type": "WorkTable Scan",
  "Node Type": "Foreign Scan",
  "Node Type": "Nested Loop",
  "Node Type": "Merge Join",
  "Node Type": "Hash Join",
  "Node Type": "Materialize",
  "Node Type": "Sort",
  "Node Type": "Group",
  "Node Type": "Aggregate",
  "Node Type": "WindowAgg",
  "Node Type": "Unique",
  "Node Type": "Hash",
  "Node Type": "SetOp",
  "Node Type": "LockRows",
  "Node Type": "Limit",
  "Node Type": "Sample Scan",
  "Node Type": "Gather",
  "Node Type": "ProjectSet",
  "Node Type": "Table Function Scan",
  "Node Type": "Named Tuplestore Scan",
  "Node Type": "Gather Merge",
  "Parent Relationship": "Outer",
  "Parent Relationship": "Inner",
  "Parent Relationship": "Subquery",
  "Parent Relationship": "Member",
  "Parent Relationship": "InitPlan",
  "Parent Relationship": "SubPlan",
  "Scan Direction": "Backward",
  "Scan Direction": "NoMovement",
  "Scan Direction": "Forward",
  "Index Name": 0,
  "Relation Name": 0,
  "Function Name": 0,
  "CTE Name": 0,
  "Schema": 0,
  "Alias": 0,
  "Output": "[]",
  "Merge Cond": "a",
  "Strategy": "Plain",
  "Strategy": "Sorted",
  "Strategy": "Hashed",
  "Strategy": "Mixed",
  "Join Type": "Inner",
  "Join Type": "Left",
  "Join Type": "Full",
  "Join Type": "Right",
  "Join Type": "Semi",
  "Join Type": "Anti",
  "Command": "Intersect",
  "Command": "Intersect All",
  "Command": "Except",
  "Command": "Except All",
  "Sort Method": "top-N heapsort",
  "Sort Method": "quicksort",
  "Sort Method": "external sort",
  "Sort Method": "external merge",
  "Sort Method": "still in progress",
  "Sort Key": "a",
  "Group Key": "a",
  "Grouping Sets": "a",
  "Group Keys": "a",
  "Hash Keys": "a",
  "Hash Key": "a",
  "Parallel Aware": "true",
  "Workers Planned": "0",
  "Workers Launched": "0",
  "Workers": "x",
  "Worker Number": "0",
  "Async Capable": "false",
  "Filter": "a",
  "Join Filter": "a",
  "Hash Cond": "a",
  "Index Cond": "a",
  "TID Cond": "a",
  "Recheck Cond": "a",
  "Conflict Resolution": "a",
  "Conflict Arbiter Indexes": "a",
  "Tuples Inserted": 0,
  "Conflicting Tuples": 0,
  "Target Tables": "a",
  "Operation": "Insert",
  "Operation": "Delete",
  "Operation": "Update",
  "Subplan Name": "a",
  "Triggers": 0,
  "Trigger": 0,
  "Trigger Name": 0,
  "Relation": 0,
  "Constraint Name": 0,
  "Function Call": 0,
  "Startup Cost": 0,
  "Total Cost": 0,
  "Plan Rows": 0,
  "Plan Width": 0,
  "Actual Startup Time": 0,
  "Actual Total Time": 0,
  "Actual Rows": 0,
  "Actual Loops": 0,
  "Heap Fetches": 0,
  "Shared Hit Blocks": 0,
  "Shared Read Blocks": 0,
  "Shared Dirtied Blocks": 0,
  "Shared Written Blocks": 0,
  "Local Hit Blocks": 0,
  "Local Read Blocks": 0,
  "Local Dirtied Blocks": 0,
  "Local Written Blocks": 0,
  "Temp Read Blocks": 0,
  "Temp Written Blocks": 0,
  "I/O Read Time": 0,
  "I/O Write Time": 0,
  "Sort Space Used": 0,
  "Sort Space Type": "Disk",
  "Sort Space Type": "Memory",
  "Peak Memory Usage": 0,
  "Original Hash Batches": 0,
  "Original Hash Buckets": 0
}'),(-2, '###### Plan -2: all properties 2/2',
 '{
  "Hash Batches": 0,
  "Hash Buckets": 0,
  "Rows Removed by Filter": 0,
  "Rows Removed by Index Recheck": 0,
  "Time": 0,
  "Calls": 0,
  "Planning Time": 0,
  "Execution Time": 0,
  "Exact Heap Blocks": 0,
  "Lossy Heap Blocks": 0,
  "Rows Removed by Join Filter": 0,
  "Target Tables": "dummy",
  "Conflict Resolution": "NOTHING",
  "Conflict Arbiter Indexes": "ia",
  "Tuples Inserted": 123,
  "Conflicting Tuples": 234,
  "Sampling Method": "system",
  "Sampling Parameters": ["''10''::real"],
  "Repeatable Seed": "''0''::double precision",
  "Workers": "dummy",
  "Worker Number": 0,
  "Async Capable": 0
}'),(-3, '###### Plan -3: expression tokens 1/1',
 '{"Output": ["~NULL!1.2@''abc''^123|CURRENT_CATALOG`CURRENT_DATE?CURRENT_ROLE+CURRENT_SCHEMA-CURRENT_TIME*CURRENT_TIMESTAMP/CURRENT_USER%LOCALTIME<LOCALTIMESTAMP>true=false"]}
}'),(-4, '###### Plan -4: some properties plus unknown key',
 '{
  "Plan": 0,
  "Plans": 0,
  "Node Type": "Result",
  "Node Type": "ModifyTable",
  "Node Type": "Append",
  "Node Type": "Merge Append",
  "Node Type": "Recursive Union",
  "Node Type": "BitmapAnd",
  "Node Type": "BitmapOr",
  "Node Type": "Seq Scan",
  "Node Type": "Index Scan",
  "Node Type": "Index Only Scan",
  "Node Type": "Bitmap Index Scan",
  "Node Type": "Bitmap Heap Scan",
  "Node Type": "Tid Scan",
  "Node Type": "Subquery Scan",
  "Node Type": "Function Scan",
  "Node Type": "Values Scan",
  "Node Type": "CTE Scan",
  "Node Type": "WorkTable Scan",
  "Node Type": "Foreign Scan",
  "Node Type": "Nested Loop",
  "Node Type": "Merge Join",
  "Node Type": "Hash Join",
  "Node Type": "Materialize",
  "Node Type": "Sort",
  "Node Type": "Group",
  "Node Type": "Aggregate",
  "Node Type": "WindowAgg",
  "Node Type": "Unique",
  "Node Type": "Hash",
  "Node Type": "SetOp",
  "Node Type": "LockRows",
  "Node Type": "Limit",
  "Node Type": "Sample Scan",
  "Node Type": "Gather",
  "Node Type": "ProjectSet",
  "Node Type": "Table Function Scan",
  "Node Type": "Named Tuplestore Scan",
  "Node Type": "Gather Merge",
  "Parent Relationship": "Outer",
  "Parent Relationship": "Inner",
  "Parent Relationship": "Subquery",
  "Parent Relationship": "Member",
  "Parent Relationship": "InitPlan",
  "Parent Relationship": "SubPlan",
  "Scan Direction": "Backward",
  "Scan Direction": "NoMovement",
  "Scan Direction": "Forward",
  "Index Name": 0,
  "Relation Name": 0,
  "Function Name": 0,
  "CTE Name": 0,
  "Schema": 0,
  "Alias": 0,
  "Output": "[]",
  "Merge Cond": "a",
  "Strategy": "Plain",
  "Strategy": "Sorted",
  "Strategy": "Hashed",
  "Strategy": "Mixed",
  "Join Type": "Inner",
  "Join Type": "Left",
  "Join Type": "Full",
  "Join Type": "Right",
  "Join Type": "Semi",
  "Join Type": "Anti",
  "Command": "Intersect",
  "Command": "Intersect All",
  "Command": "Except",
  "Command": "Except All",
  "Sort Method": "top-N heapsort",
  "Sort Method": "quicksort",
  "Sort Method": "external sort",
  "Sort Method": "external merge",
  "Sort Method": "still in progress",
  "Sort Key": "a",
  "Group Key": "a",
  "Grouping Sets": "a",
  "Group Keys": "a",
  "Hash Keys": "a",
  "Hash Key": "a",
  "Parallel Aware": "true",
  "Workers Planned": "0",
  "Workers Launched": "0",
  "Workers": "x",
  "Worker Number": "0",
  "Async Capable": "false",
  "Filter": "a",
  "Join Filter": "a",
  "Hash Cond": "a",
  "Index Cond": "a",
  "TID Cond": "a",
  "Recheck Cond": "a",
  "Conflict Resolution": "a",
  "Conflict Arbiter Indexes": "a",
  "Tuples Inserted": 0,
  "Conflicting Tuples": 0,
  "Target Tables": "a",
  "Operation": "Insert",
  "Operation": "Delete",
  "Operation": "Update",
  "Subplan Name": "a",
  "Triggers": 0,
  "Trigger": 0,
  "Trigger Name": 0,
  "Relation": 0,
  "Constraint Name": 0,
  "Function Call": 0,
  "Startup Cost": 0,
  "Total Cost": 0,
  "Plan Rows": 0,
  "Plan Width": 0,
  "Actual Startup Time": 0,
  "Actual Total Time": 0,
  "Actual Rows": 0,
  "Actual Loops": 0,
  "Heap Fetches": 0,
  "Shared Hit Blocks": 0,
  "Shared Read Blocks": 0,
  "Shared Dirtied Blocks": 0,
  "Shared Written Blocks": 0,
  "Local Hit Blocks": 0,
  "Local Read Blocks": 0,
  "Local Dirtied Blocks": 0,
  "Local Written Blocks": 0,
  "Temp Read Blocks": 0,
  "Temp Written Blocks": 0,
  "I/O Read Time": 0,
  "I/O Write Time": 0,
  "Sort Space Used": 0,
  "Sort Space Type": "Disk",
  "Sort Space Type": "Memory",
  "Peak Memory Usage": 0,
  "Original Hash Batches": 0,
  "Original Hash Buckets": 0,
  "Unknown Key": "Unknown Value"
}'),
(1, '###### Plan 1: Insert, Trigger',
 '{
  "Plan": {
    "Node Type": "ModifyTable",
    "Operation": "Insert",
    "Parallel Aware": false,
    "Async Capable": false,
    "Relation Name": "tt1",
    "Schema": "public",
    "Alias": "tt1",
    "Startup Cost": 0.00,
    "Total Cost": 100.01,
    "Plan Rows": 0,
    "Plan Width": 0,
    "Actual Startup Time": 92.484,
    "Actual Total Time": 92.485,
    "Actual Rows": 0,
    "Actual Loops": 1,
    "Shared Hit Blocks": 29749,
    "Shared Read Blocks": 2,
    "Shared Dirtied Blocks": 85,
    "Shared Written Blocks": 87,
    "Local Hit Blocks": 0,
    "Local Read Blocks": 0,
    "Local Dirtied Blocks": 0,
    "Local Written Blocks": 0,
    "Temp Read Blocks": 0,
    "Temp Written Blocks": 0,
    "Plans": [
      {
        "Node Type": "Function Scan",
        "Parent Relationship": "Outer",
        "Parallel Aware": false,
        "Async Capable": false,
        "Function Name": "generate_series",
        "Schema": "pg_catalog",
        "Alias": "a",
        "Startup Cost": 0.00,
        "Total Cost": 100.01,
        "Plan Rows": 10001,
        "Plan Width": 40,
        "Actual Startup Time": 0.838,
        "Actual Total Time": 3.036,
        "Actual Rows": 10001,
        "Actual Loops": 1,
        "Output": ["a.a", "NULL::integer", "NULL::text"],
        "Function Call": "generate_series(0, 10000)",
        "Shared Hit Blocks": 0,
        "Shared Read Blocks": 0,
        "Shared Dirtied Blocks": 0,
        "Shared Written Blocks": 0,
        "Local Hit Blocks": 0,
        "Local Read Blocks": 0,
        "Local Dirtied Blocks": 0,
        "Local Written Blocks": 0,
        "Temp Read Blocks": 0,
        "Temp Written Blocks": 0
      }
    ]
  },
  "Query Identifier": -8372225624418172470,
  "Planning": {
    "Shared Hit Blocks": 0,
    "Shared Read Blocks": 0,
    "Shared Dirtied Blocks": 0,
    "Shared Written Blocks": 0,
    "Local Hit Blocks": 0,
    "Local Read Blocks": 0,
    "Local Dirtied Blocks": 0,
    "Local Written Blocks": 0,
    "Temp Read Blocks": 0,
    "Temp Written Blocks": 0
  },
  "Planning Time": 0.051,
  "Triggers": [
    {
      "Trigger Name": "tt1_trig_1",
      "Relation": "tt1",
      "Time": 21.510,
      "Calls": 10001
    },
    {
      "Trigger Name": "tt1_trig_2",
      "Relation": "tt1",
      "Time": 19.346,
      "Calls": 10001
    }
  ],
  "Execution Time": 93.121
}'),
(2, '###### Plan 2: Update, Trigger',
 '{
  "Plan": {
    "Node Type": "ModifyTable",
    "Operation": "Update",
    "Parallel Aware": false,
    "Async Capable": false,
    "Relation Name": "tt1",
    "Schema": "public",
    "Alias": "tt1",
    "Startup Cost": 0.00,
    "Total Cost": 137.50,
    "Plan Rows": 0,
    "Plan Width": 0,
    "Actual Startup Time": 136.958,
    "Actual Total Time": 136.958,
    "Actual Rows": 0,
    "Actual Loops": 1,
    "Shared Hit Blocks": 60223,
    "Shared Read Blocks": 0,
    "Shared Dirtied Blocks": 81,
    "Shared Written Blocks": 81,
    "Local Hit Blocks": 0,
    "Local Read Blocks": 0,
    "Local Dirtied Blocks": 0,
    "Local Written Blocks": 0,
    "Temp Read Blocks": 0,
    "Temp Written Blocks": 0,
    "Plans": [
      {
        "Node Type": "Seq Scan",
        "Parent Relationship": "Outer",
        "Parallel Aware": false,
        "Async Capable": false,
        "Relation Name": "tt1",
        "Schema": "public",
        "Alias": "tt1",
        "Startup Cost": 0.00,
        "Total Cost": 137.50,
        "Plan Rows": 6600,
        "Plan Width": 10,
        "Actual Startup Time": 0.020,
        "Actual Total Time": 3.567,
        "Actual Rows": 10001,
        "Actual Loops": 1,
        "Output": ["(a + 1)", "ctid"],
        "Shared Hit Blocks": 55,
        "Shared Read Blocks": 0,
        "Shared Dirtied Blocks": 0,
        "Shared Written Blocks": 0,
        "Local Hit Blocks": 0,
        "Local Read Blocks": 0,
        "Local Dirtied Blocks": 0,
        "Local Written Blocks": 0,
        "Temp Read Blocks": 0,
        "Temp Written Blocks": 0
      }
    ]
  },
  "Query Identifier": 2704190834866505627,
  "Planning": {
    "Shared Hit Blocks": 8,
    "Shared Read Blocks": 0,
    "Shared Dirtied Blocks": 0,
    "Shared Written Blocks": 0,
    "Local Hit Blocks": 0,
    "Local Read Blocks": 0,
    "Local Dirtied Blocks": 0,
    "Local Written Blocks": 0,
    "Temp Read Blocks": 0,
    "Temp Written Blocks": 0
  },
  "Planning Time": 0.127,
  "Triggers": [
    {
      "Trigger Name": "tt1_trig_1",
      "Relation": "tt1",
      "Time": 23.778,
      "Calls": 10001
    },
    {
      "Trigger Name": "tt1_trig_2",
      "Relation": "tt1",
      "Time": 20.297,
      "Calls": 10001
    }
  ],
  "Execution Time": 137.115
}'),
(3, '###### Plan 3: Delete',
 '{
  "Plan": {
    "Node Type": "ModifyTable",
    "Operation": "Delete",
    "Parallel Aware": false,
    "Async Capable": false,
    "Relation Name": "tt1",
    "Schema": "public",
    "Alias": "tt1",
    "Startup Cost": 0.00,
    "Total Cost": 305.20,
    "Plan Rows": 0,
    "Plan Width": 0,
    "Actual Startup Time": 4.060,
    "Actual Total Time": 4.061,
    "Actual Rows": 0,
    "Actual Loops": 1,
    "Shared Hit Blocks": 1109,
    "Shared Read Blocks": 0,
    "Shared Dirtied Blocks": 0,
    "Shared Written Blocks": 0,
    "Local Hit Blocks": 0,
    "Local Read Blocks": 0,
    "Local Dirtied Blocks": 0,
    "Local Written Blocks": 0,
    "Temp Read Blocks": 0,
    "Temp Written Blocks": 0,
    "Plans": [
      {
        "Node Type": "Seq Scan",
        "Parent Relationship": "Outer",
        "Parallel Aware": false,
        "Async Capable": false,
        "Relation Name": "tt1",
        "Schema": "public",
        "Alias": "tt1",
        "Startup Cost": 0.00,
        "Total Cost": 305.20,
        "Plan Rows": 65,
        "Plan Width": 6,
        "Actual Startup Time": 1.294,
        "Actual Total Time": 3.233,
        "Actual Rows": 1000,
        "Actual Loops": 1,
        "Output": ["ctid"],
        "Filter": "((tt1.a % 10) = 0)",
        "Rows Removed by Filter": 9001,
        "Shared Hit Blocks": 109,
        "Shared Read Blocks": 0,
        "Shared Dirtied Blocks": 0,
        "Shared Written Blocks": 0,
        "Local Hit Blocks": 0,
        "Local Read Blocks": 0,
        "Local Dirtied Blocks": 0,
        "Local Written Blocks": 0,
        "Temp Read Blocks": 0,
        "Temp Written Blocks": 0
      }
    ]
  },
  "Query Identifier": -6816770477772925748,
  "Planning": {
    "Shared Hit Blocks": 5,
    "Shared Read Blocks": 1,
    "Shared Dirtied Blocks": 0,
    "Shared Written Blocks": 0,
    "Local Hit Blocks": 0,
    "Local Read Blocks": 0,
    "Local Dirtied Blocks": 0,
    "Local Written Blocks": 0,
    "Temp Read Blocks": 0,
    "Temp Written Blocks": 0
  },
  "Planning Time": 0.120,
  "Triggers": [
  ],
  "Execution Time": 4.175
}'),
(4, '###### Plan 4: Result, Append Seq Scan',
 '{
  "Plan": {
    "Node Type": "Result",
    "Parallel Aware": false,
    "Async Capable": false,
    "Startup Cost": 0.00,
    "Total Cost": 743.05,
    "Plan Rows": 20002,
    "Plan Width": 12,
    "Actual Startup Time": 0.740,
    "Actual Total Time": 7.189,
    "Actual Rows": 20002,
    "Actual Loops": 1,
    "Output": ["((tt1.a + 1))", "(3)", "1"],
    "Shared Hit Blocks": 218,
    "Shared Read Blocks": 0,
    "Shared Dirtied Blocks": 0,
    "Shared Written Blocks": 0,
    "Local Hit Blocks": 0,
    "Local Read Blocks": 0,
    "Local Dirtied Blocks": 0,
    "Local Written Blocks": 0,
    "Temp Read Blocks": 0,
    "Temp Written Blocks": 0,
    "Plans": [
      {
        "Node Type": "Append",
        "Parent Relationship": "Outer",
        "Parallel Aware": false,
        "Async Capable": false,
        "Startup Cost": 0.00,
        "Total Cost": 543.03,
        "Plan Rows": 20002,
        "Plan Width": 8,
        "Actual Startup Time": 0.739,
        "Actual Total Time": 5.185,
        "Actual Rows": 20002,
        "Actual Loops": 1,
        "Shared Hit Blocks": 218,
        "Shared Read Blocks": 0,
        "Shared Dirtied Blocks": 0,
        "Shared Written Blocks": 0,
        "Local Hit Blocks": 0,
        "Local Read Blocks": 0,
        "Local Dirtied Blocks": 0,
        "Local Written Blocks": 0,
        "Temp Read Blocks": 0,
        "Temp Written Blocks": 0,
        "Subplans Removed": 0,
        "Plans": [
          {
            "Node Type": "Seq Scan",
            "Parent Relationship": "Member",
            "Parallel Aware": false,
            "Async Capable": false,
            "Relation Name": "tt1",
            "Schema": "public",
            "Alias": "tt1",
            "Startup Cost": 0.00,
            "Total Cost": 288.01,
            "Plan Rows": 10001,
            "Plan Width": 8,
            "Actual Startup Time": 0.738,
            "Actual Total Time": 2.397,
            "Actual Rows": 10001,
            "Actual Loops": 1,
            "Output": ["(tt1.a + 1)", "3"],
            "Shared Hit Blocks": 163,
            "Shared Read Blocks": 0,
            "Shared Dirtied Blocks": 0,
            "Shared Written Blocks": 0,
            "Local Hit Blocks": 0,
            "Local Read Blocks": 0,
            "Local Dirtied Blocks": 0,
            "Local Written Blocks": 0,
            "Temp Read Blocks": 0,
            "Temp Written Blocks": 0
          },
          {
            "Node Type": "Seq Scan",
            "Parent Relationship": "Member",
            "Parallel Aware": false,
            "Async Capable": false,
            "Relation Name": "tt2",
            "Schema": "public",
            "Alias": "tt2",
            "Startup Cost": 0.00,
            "Total Cost": 155.01,
            "Plan Rows": 10001,
            "Plan Width": 8,
            "Actual Startup Time": 0.009,
            "Actual Total Time": 1.460,
            "Actual Rows": 10001,
            "Actual Loops": 1,
            "Output": ["tt2.a", "4"],
            "Shared Hit Blocks": 55,
            "Shared Read Blocks": 0,
            "Shared Dirtied Blocks": 0,
            "Shared Written Blocks": 0,
            "Local Hit Blocks": 0,
            "Local Read Blocks": 0,
            "Local Dirtied Blocks": 0,
            "Local Written Blocks": 0,
            "Temp Read Blocks": 0,
            "Temp Written Blocks": 0
          }
        ]
      }
    ]
  },
  "Query Identifier": 7611700009265054887,
  "Planning": {
    "Shared Hit Blocks": 28,
    "Shared Read Blocks": 0,
    "Shared Dirtied Blocks": 0,
    "Shared Written Blocks": 0,
    "Local Hit Blocks": 0,
    "Local Read Blocks": 0,
    "Local Dirtied Blocks": 0,
    "Local Written Blocks": 0,
    "Temp Read Blocks": 0,
    "Temp Written Blocks": 0
  },
  "Planning Time": 0.207,
  "Triggers": [
  ],
  "Execution Time": 8.280
}'),
(5, '###### Plan 5: Index scan (forward) ANY, array in expr, escape',
 E'{
  "Plan": {
    "Node Type": "Index Scan",
    "Parallel Aware": false,
    "Async Capable": false,
    "Scan Direction": "Forward",
    "Index Name": "i_tt1",
    "Relation Name": "tt1",
    "Schema": "public",
    "Alias": "x\\"y",
    "Startup Cost": 0.29,
    "Total Cost": 21.21,
    "Plan Rows": 4,
    "Plan Width": 12,
    "Actual Startup Time": 0.015,
    "Actual Total Time": 0.055,
    "Actual Rows": 4,
    "Actual Loops": 1,
    "Output": ["a", "b", "c"],
    "Index Cond": "(\\"x\\"\\"y\\".a = ANY (\'{50,120,300,500}\'::integer[]))",
    "Rows Removed by Index Recheck": 0,
    "Shared Hit Blocks": 24,
    "Shared Read Blocks": 0,
    "Shared Dirtied Blocks": 0,
    "Shared Written Blocks": 0,
    "Local Hit Blocks": 0,
    "Local Read Blocks": 0,
    "Local Dirtied Blocks": 0,
    "Local Written Blocks": 0,
    "Temp Read Blocks": 0,
    "Temp Written Blocks": 0
  },
  "Query Identifier": 8414316098970767377,
  "Planning": {
    "Shared Hit Blocks": 6,
    "Shared Read Blocks": 0,
    "Shared Dirtied Blocks": 0,
    "Shared Written Blocks": 0,
    "Local Hit Blocks": 0,
    "Local Read Blocks": 0,
    "Local Dirtied Blocks": 0,
    "Local Written Blocks": 0,
    "Temp Read Blocks": 0,
    "Temp Written Blocks": 0
  },
  "Planning Time": 0.106,
  "Triggers": [
  ],
  "Execution Time": 0.129
}'),
(6, '###### Plan 6: Index scan (backward), MergeJoin, Sort, quicksort, alias',
 '{
  "Plan": {
    "Node Type": "Limit",
    "Parallel Aware": false,
    "Async Capable": false,
    "Startup Cost": 819.75,
    "Total Cost": 820.68,
    "Plan Rows": 10,
    "Plan Width": 12,
    "Actual Startup Time": 6.304,
    "Actual Total Time": 6.305,
    "Actual Rows": 0,
    "Actual Loops": 1,
    "Output": ["x.b", "x.c", "x.a"],
    "Shared Hit Blocks": 59,
    "Shared Read Blocks": 0,
    "Shared Dirtied Blocks": 0,
    "Shared Written Blocks": 0,
    "Local Hit Blocks": 0,
    "Local Read Blocks": 0,
    "Local Dirtied Blocks": 0,
    "Local Written Blocks": 0,
    "Temp Read Blocks": 0,
    "Temp Written Blocks": 0,
    "Plans": [
      {
        "Node Type": "Merge Join",
        "Parent Relationship": "Outer",
        "Parallel Aware": false,
        "Async Capable": false,
        "Join Type": "Inner",
        "Startup Cost": 819.75,
        "Total Cost": 1746.80,
        "Plan Rows": 10001,
        "Plan Width": 12,
        "Actual Startup Time": 6.303,
        "Actual Total Time": 6.304,
        "Actual Rows": 0,
        "Actual Loops": 1,
        "Output": ["x.b", "x.c", "x.a"],
        "Inner Unique": false,
        "Merge Cond": "(x.a = (((- y.b) * 3)))",
        "Shared Hit Blocks": 59,
        "Shared Read Blocks": 0,
        "Shared Dirtied Blocks": 0,
        "Shared Written Blocks": 0,
        "Local Hit Blocks": 0,
        "Local Read Blocks": 0,
        "Local Dirtied Blocks": 0,
        "Local Written Blocks": 0,
        "Temp Read Blocks": 0,
        "Temp Written Blocks": 0,
        "Plans": [
          {
            "Node Type": "Index Scan",
            "Parent Relationship": "Outer",
            "Parallel Aware": false,
            "Async Capable": false,
            "Scan Direction": "Backward",
            "Index Name": "i_tt1",
            "Relation Name": "tt1",
            "Schema": "public",
            "Alias": "x",
            "Startup Cost": 0.29,
            "Total Cost": 652.30,
            "Plan Rows": 10001,
            "Plan Width": 12,
            "Actual Startup Time": 0.015,
            "Actual Total Time": 0.015,
            "Actual Rows": 1,
            "Actual Loops": 1,
            "Output": ["x.a", "x.b", "x.c"],
            "Shared Hit Blocks": 4,
            "Shared Read Blocks": 0,
            "Shared Dirtied Blocks": 0,
            "Shared Written Blocks": 0,
            "Local Hit Blocks": 0,
            "Local Read Blocks": 0,
            "Local Dirtied Blocks": 0,
            "Local Written Blocks": 0,
            "Temp Read Blocks": 0,
            "Temp Written Blocks": 0
          },
          {
            "Node Type": "Sort",
            "Parent Relationship": "Inner",
            "Parallel Aware": false,
            "Async Capable": false,
            "Startup Cost": 819.47,
            "Total Cost": 844.47,
            "Plan Rows": 10001,
            "Plan Width": 4,
            "Actual Startup Time": 4.788,
            "Actual Total Time": 5.354,
            "Actual Rows": 10001,
            "Actual Loops": 1,
            "Output": ["y.b", "(((- y.b) * 3))"],
            "Sort Key": ["(((- y.b) * 3)) DESC"],
            "Sort Method": "quicksort",
            "Sort Space Used": 811,
            "Sort Space Type": "Memory",
            "Shared Hit Blocks": 55,
            "Shared Read Blocks": 0,
            "Shared Dirtied Blocks": 0,
            "Shared Written Blocks": 0,
            "Local Hit Blocks": 0,
            "Local Read Blocks": 0,
            "Local Dirtied Blocks": 0,
            "Local Written Blocks": 0,
            "Temp Read Blocks": 0,
            "Temp Written Blocks": 0,
            "Plans": [
              {
                "Node Type": "Seq Scan",
                "Parent Relationship": "Outer",
                "Parallel Aware": false,
                "Async Capable": false,
                "Relation Name": "tt2",
                "Schema": "public",
                "Alias": "y",
                "Startup Cost": 0.00,
                "Total Cost": 155.01,
                "Plan Rows": 10001,
                "Plan Width": 4,
                "Actual Startup Time": 0.009,
                "Actual Total Time": 1.728,
                "Actual Rows": 10001,
                "Actual Loops": 1,
                "Output": ["y.b", "((- y.b) * 3)"],
                "Shared Hit Blocks": 55,
                "Shared Read Blocks": 0,
                "Shared Dirtied Blocks": 0,
                "Shared Written Blocks": 0,
                "Local Hit Blocks": 0,
                "Local Read Blocks": 0,
                "Local Dirtied Blocks": 0,
                "Local Written Blocks": 0,
                "Temp Read Blocks": 0,
                "Temp Written Blocks": 0
              }
            ]
          }
        ]
      }
    ]
  },
  "Query Identifier": 1186469209037947787,
  "Planning": {
    "Shared Hit Blocks": 13,
    "Shared Read Blocks": 1,
    "Shared Dirtied Blocks": 0,
    "Shared Written Blocks": 0,
    "Local Hit Blocks": 0,
    "Local Read Blocks": 0,
    "Local Dirtied Blocks": 0,
    "Local Written Blocks": 0,
    "Temp Read Blocks": 0,
    "Temp Written Blocks": 0
  },
  "Planning Time": 0.196,
  "Triggers": [
  ],
  "Execution Time": 6.619
}'),
(7, '###### Plan 7: IndexOnlyScan',
 '{
  "Plan": {
    "Node Type": "Index Only Scan",
    "Parallel Aware": false,
    "Async Capable": false,
    "Scan Direction": "Forward",
    "Index Name": "i_tt1",
    "Relation Name": "tt1",
    "Schema": "public",
    "Alias": "tt1",
    "Startup Cost": 0.29,
    "Total Cost": 8.46,
    "Plan Rows": 10,
    "Plan Width": 4,
    "Actual Startup Time": 0.006,
    "Actual Total Time": 0.151,
    "Actual Rows": 10,
    "Actual Loops": 1,
    "Output": ["a"],
    "Index Cond": "(tt1.a < 10)",
    "Rows Removed by Index Recheck": 0,
    "Heap Fetches": 29,
    "Shared Hit Blocks": 31,
    "Shared Read Blocks": 0,
    "Shared Dirtied Blocks": 0,
    "Shared Written Blocks": 0,
    "Local Hit Blocks": 0,
    "Local Read Blocks": 0,
    "Local Dirtied Blocks": 0,
    "Local Written Blocks": 0,
    "Temp Read Blocks": 0,
    "Temp Written Blocks": 0
  },
  "Query Identifier": -3543250012458653749,
  "Planning": {
    "Shared Hit Blocks": 4,
    "Shared Read Blocks": 0,
    "Shared Dirtied Blocks": 0,
    "Shared Written Blocks": 0,
    "Local Hit Blocks": 0,
    "Local Read Blocks": 0,
    "Local Dirtied Blocks": 0,
    "Local Written Blocks": 0,
    "Temp Read Blocks": 0,
    "Temp Written Blocks": 0
  },
  "Planning Time": 0.082,
  "Triggers": [
  ],
  "Execution Time": 0.210
}'),
(8, '###### Plan 8: Plain Aggregate, CTE, Recursive Union, WorkTable Scan, CTE Scan',
 '{
  "Plan": {
    "Node Type": "Aggregate",
    "Strategy": "Plain",
    "Partial Mode": "Simple",
    "Parallel Aware": false,
    "Async Capable": false,
    "Startup Cost": 3.34,
    "Total Cost": 3.35,
    "Plan Rows": 1,
    "Plan Width": 8,
    "Actual Startup Time": 0.035,
    "Actual Total Time": 0.036,
    "Actual Rows": 1,
    "Actual Loops": 1,
    "Output": ["sum(cte1.a)"],
    "Shared Hit Blocks": 0,
    "Shared Read Blocks": 0,
    "Shared Dirtied Blocks": 0,
    "Shared Written Blocks": 0,
    "Local Hit Blocks": 0,
    "Local Read Blocks": 0,
    "Local Dirtied Blocks": 0,
    "Local Written Blocks": 0,
    "Temp Read Blocks": 0,
    "Temp Written Blocks": 0,
    "Plans": [
      {
        "Node Type": "Recursive Union",
        "Parent Relationship": "InitPlan",
        "Subplan Name": "CTE cte1",
        "Parallel Aware": false,
        "Async Capable": false,
        "Startup Cost": 0.00,
        "Total Cost": 2.64,
        "Plan Rows": 31,
        "Plan Width": 4,
        "Actual Startup Time": 0.001,
        "Actual Total Time": 0.016,
        "Actual Rows": 10,
        "Actual Loops": 1,
        "Shared Hit Blocks": 0,
        "Shared Read Blocks": 0,
        "Shared Dirtied Blocks": 0,
        "Shared Written Blocks": 0,
        "Local Hit Blocks": 0,
        "Local Read Blocks": 0,
        "Local Dirtied Blocks": 0,
        "Local Written Blocks": 0,
        "Temp Read Blocks": 0,
        "Temp Written Blocks": 0,
        "Plans": [
          {
            "Node Type": "Result",
            "Parent Relationship": "Outer",
            "Parallel Aware": false,
            "Async Capable": false,
            "Startup Cost": 0.00,
            "Total Cost": 0.01,
            "Plan Rows": 1,
            "Plan Width": 4,
            "Actual Startup Time": 0.001,
            "Actual Total Time": 0.001,
            "Actual Rows": 1,
            "Actual Loops": 1,
            "Output": ["1"],
            "Shared Hit Blocks": 0,
            "Shared Read Blocks": 0,
            "Shared Dirtied Blocks": 0,
            "Shared Written Blocks": 0,
            "Local Hit Blocks": 0,
            "Local Read Blocks": 0,
            "Local Dirtied Blocks": 0,
            "Local Written Blocks": 0,
            "Temp Read Blocks": 0,
            "Temp Written Blocks": 0
          },
          {
            "Node Type": "WorkTable Scan",
            "Parent Relationship": "Inner",
            "Parallel Aware": false,
            "Async Capable": false,
            "CTE Name": "cte1",
            "Alias": "cte1_1",
            "Startup Cost": 0.00,
            "Total Cost": 0.23,
            "Plan Rows": 3,
            "Plan Width": 4,
            "Actual Startup Time": 0.000,
            "Actual Total Time": 0.001,
            "Actual Rows": 1,
            "Actual Loops": 10,
            "Output": ["(cte1_1.a + 1)"],
            "Filter": "(cte1_1.a < 10)",
            "Rows Removed by Filter": 0,
            "Shared Hit Blocks": 0,
            "Shared Read Blocks": 0,
            "Shared Dirtied Blocks": 0,
            "Shared Written Blocks": 0,
            "Local Hit Blocks": 0,
            "Local Read Blocks": 0,
            "Local Dirtied Blocks": 0,
            "Local Written Blocks": 0,
            "Temp Read Blocks": 0,
            "Temp Written Blocks": 0
          }
        ]
      },
      {
        "Node Type": "CTE Scan",
        "Parent Relationship": "Outer",
        "Parallel Aware": false,
        "Async Capable": false,
        "CTE Name": "cte1",
        "Alias": "cte1",
        "Startup Cost": 0.00,
        "Total Cost": 0.62,
        "Plan Rows": 31,
        "Plan Width": 4,
        "Actual Startup Time": 0.002,
        "Actual Total Time": 0.020,
        "Actual Rows": 10,
        "Actual Loops": 1,
        "Output": ["cte1.a"],
        "Shared Hit Blocks": 0,
        "Shared Read Blocks": 0,
        "Shared Dirtied Blocks": 0,
        "Shared Written Blocks": 0,
        "Local Hit Blocks": 0,
        "Local Read Blocks": 0,
        "Local Dirtied Blocks": 0,
        "Local Written Blocks": 0,
        "Temp Read Blocks": 0,
        "Temp Written Blocks": 0
      }
    ]
  },
  "Query Identifier": -3904328021483783591,
  "Planning": {
    "Shared Hit Blocks": 2,
    "Shared Read Blocks": 1,
    "Shared Dirtied Blocks": 0,
    "Shared Written Blocks": 0,
    "Local Hit Blocks": 0,
    "Local Read Blocks": 0,
    "Local Dirtied Blocks": 0,
    "Local Written Blocks": 0,
    "Temp Read Blocks": 0,
    "Temp Written Blocks": 0
  },
  "Planning Time": 0.084,
  "Triggers": [
  ],
  "Execution Time": 0.185
}'),
(9, '###### Plan 9: FunctionScan, Hash/HashJoin, Nested Loop',
 '{
  "Plan": {
    "Node Type": "Hash Join",
    "Parallel Aware": false,
    "Async Capable": false,
    "Join Type": "Left",
    "Startup Cost": 1.09,
    "Total Cost": 2.37,
    "Plan Rows": 100,
    "Plan Width": 64,
    "Actual Startup Time": 0.058,
    "Actual Total Time": 0.063,
    "Actual Rows": 6,
    "Actual Loops": 1,
    "Output": ["d.datname"],
    "Inner Unique": true,
    "Hash Cond": "(s.datid = d.oid)",
    "Shared Hit Blocks": 1,
    "Shared Read Blocks": 0,
    "Shared Dirtied Blocks": 0,
    "Shared Written Blocks": 0,
    "Local Hit Blocks": 0,
    "Local Read Blocks": 0,
    "Local Dirtied Blocks": 0,
    "Local Written Blocks": 0,
    "Temp Read Blocks": 0,
    "Temp Written Blocks": 0,
    "Plans": [
      {
        "Node Type": "Function Scan",
        "Parent Relationship": "Outer",
        "Parallel Aware": false,
        "Async Capable": false,
        "Function Name": "pg_stat_get_activity",
        "Schema": "pg_catalog",
        "Alias": "s",
        "Startup Cost": 0.00,
        "Total Cost": 1.00,
        "Plan Rows": 100,
        "Plan Width": 8,
        "Actual Startup Time": 0.044,
        "Actual Total Time": 0.046,
        "Actual Rows": 6,
        "Actual Loops": 1,
        "Output": ["s.datid", "s.pid", "s.usesysid", "s.application_name", "s.state", "s.query", "s.wait_event_type", "s.wait_event", "s.xact_start", "s.query_start", "s.backend_start", "s.state_change", "s.client_addr", "s.client_hostname", "s.client_port", "s.backend_xid", "s.backend_xmin", "s.backend_type", "s.ssl", "s.sslversion", "s.sslcipher", "s.sslbits", "s.ssl_client_dn", "s.ssl_client_serial", "s.ssl_issuer_dn", "s.gss_auth", "s.gss_princ", "s.gss_enc", "s.gss_delegation", "s.leader_pid", "s.query_id"],
        "Function Call": "pg_stat_get_activity(NULL::integer)",
        "Shared Hit Blocks": 0,
        "Shared Read Blocks": 0,
        "Shared Dirtied Blocks": 0,
        "Shared Written Blocks": 0,
        "Local Hit Blocks": 0,
        "Local Read Blocks": 0,
        "Local Dirtied Blocks": 0,
        "Local Written Blocks": 0,
        "Temp Read Blocks": 0,
        "Temp Written Blocks": 0
      },
      {
        "Node Type": "Hash",
        "Parent Relationship": "Inner",
        "Parallel Aware": false,
        "Async Capable": false,
        "Startup Cost": 1.04,
        "Total Cost": 1.04,
        "Plan Rows": 4,
        "Plan Width": 68,
        "Actual Startup Time": 0.010,
        "Actual Total Time": 0.010,
        "Actual Rows": 4,
        "Actual Loops": 1,
        "Output": ["d.datname", "d.oid"],
        "Hash Buckets": 1024,
        "Original Hash Buckets": 1024,
        "Hash Batches": 1,
        "Original Hash Batches": 1,
        "Peak Memory Usage": 9,
        "Shared Hit Blocks": 1,
        "Shared Read Blocks": 0,
        "Shared Dirtied Blocks": 0,
        "Shared Written Blocks": 0,
        "Local Hit Blocks": 0,
        "Local Read Blocks": 0,
        "Local Dirtied Blocks": 0,
        "Local Written Blocks": 0,
        "Temp Read Blocks": 0,
        "Temp Written Blocks": 0,
        "Plans": [
          {
            "Node Type": "Seq Scan",
            "Parent Relationship": "Outer",
            "Parallel Aware": false,
            "Async Capable": false,
            "Relation Name": "pg_database",
            "Schema": "pg_catalog",
            "Alias": "d",
            "Startup Cost": 0.00,
            "Total Cost": 1.04,
            "Plan Rows": 4,
            "Plan Width": 68,
            "Actual Startup Time": 0.005,
            "Actual Total Time": 0.007,
            "Actual Rows": 4,
            "Actual Loops": 1,
            "Output": ["d.datname", "d.oid"],
            "Shared Hit Blocks": 1,
            "Shared Read Blocks": 0,
            "Shared Dirtied Blocks": 0,
            "Shared Written Blocks": 0,
            "Local Hit Blocks": 0,
            "Local Read Blocks": 0,
            "Local Dirtied Blocks": 0,
            "Local Written Blocks": 0,
            "Temp Read Blocks": 0,
            "Temp Written Blocks": 0
          }
        ]
      }
    ]
  },
  "Query Identifier": -1525892219681184217,
  "Planning": {
    "Shared Hit Blocks": 31,
    "Shared Read Blocks": 0,
    "Shared Dirtied Blocks": 0,
    "Shared Written Blocks": 0,
    "Local Hit Blocks": 0,
    "Local Read Blocks": 0,
    "Local Dirtied Blocks": 0,
    "Local Written Blocks": 0,
    "Temp Read Blocks": 0,
    "Temp Written Blocks": 0
  },
  "Planning Time": 0.255,
  "Triggers": [
  ],
  "Execution Time": 0.263
}'),
(10, '###### Plan 10: MergeAppend, Values',
 E'{
  "Plan": {
    "Node Type": "Merge Append",
    "Parallel Aware": false,
    "Async Capable": false,
    "Startup Cost": 0.36,
    "Total Cost": 752.42,
    "Plan Rows": 10004,
    "Plan Width": 4,
    "Actual Startup Time": 0.027,
    "Actual Total Time": 57.179,
    "Actual Rows": 10004,
    "Actual Loops": 1,
    "Sort Key": ["tt1.a"],
    "Shared Hit Blocks": 30076,
    "Shared Read Blocks": 0,
    "Shared Dirtied Blocks": 0,
    "Shared Written Blocks": 0,
    "Local Hit Blocks": 0,
    "Local Read Blocks": 0,
    "Local Dirtied Blocks": 0,
    "Local Written Blocks": 0,
    "Temp Read Blocks": 0,
    "Temp Written Blocks": 0,
    "Subplans Removed": 0,
    "Plans": [
      {
        "Node Type": "Index Only Scan",
        "Parent Relationship": "Member",
        "Parallel Aware": false,
        "Async Capable": false,
        "Scan Direction": "Forward",
        "Index Name": "i_tt1",
        "Relation Name": "tt1",
        "Schema": "public",
        "Alias": "tt1",
        "Startup Cost": 0.29,
        "Total Cost": 652.30,
        "Plan Rows": 10001,
        "Plan Width": 4,
        "Actual Startup Time": 0.021,
        "Actual Total Time": 56.146,
        "Actual Rows": 10001,
        "Actual Loops": 1,
        "Output": ["tt1.a"],
        "Heap Fetches": 29996,
        "Shared Hit Blocks": 30076,
        "Shared Read Blocks": 0,
        "Shared Dirtied Blocks": 0,
        "Shared Written Blocks": 0,
        "Local Hit Blocks": 0,
        "Local Read Blocks": 0,
        "Local Dirtied Blocks": 0,
        "Local Written Blocks": 0,
        "Temp Read Blocks": 0,
        "Temp Written Blocks": 0
      },
      {
        "Node Type": "Sort",
        "Parent Relationship": "Member",
        "Parallel Aware": false,
        "Async Capable": false,
        "Startup Cost": 0.06,
        "Total Cost": 0.07,
        "Plan Rows": 3,
        "Plan Width": 4,
        "Actual Startup Time": 0.006,
        "Actual Total Time": 0.007,
        "Actual Rows": 3,
        "Actual Loops": 1,
        "Output": ["\\"*VALUES*\\".column1"],
        "Sort Key": ["\\"*VALUES*\\".column1"],
        "Sort Method": "quicksort",
        "Sort Space Used": 25,
        "Sort Space Type": "Memory",
        "Shared Hit Blocks": 0,
        "Shared Read Blocks": 0,
        "Shared Dirtied Blocks": 0,
        "Shared Written Blocks": 0,
        "Local Hit Blocks": 0,
        "Local Read Blocks": 0,
        "Local Dirtied Blocks": 0,
        "Local Written Blocks": 0,
        "Temp Read Blocks": 0,
        "Temp Written Blocks": 0,
        "Plans": [
          {
            "Node Type": "Values Scan",
            "Parent Relationship": "Outer",
            "Parallel Aware": false,
            "Async Capable": false,
            "Alias": "*VALUES*",
            "Startup Cost": 0.00,
            "Total Cost": 0.04,
            "Plan Rows": 3,
            "Plan Width": 4,
            "Actual Startup Time": 0.001,
            "Actual Total Time": 0.003,
            "Actual Rows": 3,
            "Actual Loops": 1,
            "Output": ["\\"*VALUES*\\".column1"],
            "Shared Hit Blocks": 0,
            "Shared Read Blocks": 0,
            "Shared Dirtied Blocks": 0,
            "Shared Written Blocks": 0,
            "Local Hit Blocks": 0,
            "Local Read Blocks": 0,
            "Local Dirtied Blocks": 0,
            "Local Written Blocks": 0,
            "Temp Read Blocks": 0,
            "Temp Written Blocks": 0
          }
        ]
      }
    ]
  },
  "Query Identifier": 8470910150056594625,
  "Planning": {
    "Shared Hit Blocks": 0,
    "Shared Read Blocks": 0,
    "Shared Dirtied Blocks": 0,
    "Shared Written Blocks": 0,
    "Local Hit Blocks": 0,
    "Local Read Blocks": 0,
    "Local Dirtied Blocks": 0,
    "Local Written Blocks": 0,
    "Temp Read Blocks": 0,
    "Temp Written Blocks": 0
  },
  "Planning Time": 0.068,
  "Triggers": [
  ],
  "Execution Time": 57.936
}'),
(11, '###### Plan 11: Append, HashAggregate',
 '{
  "Plan": {
    "Node Type": "Aggregate",
    "Strategy": "Hashed",
    "Partial Mode": "Simple",
    "Parallel Aware": false,
    "Async Capable": false,
    "Startup Cost": 568.03,
    "Total Cost": 768.05,
    "Plan Rows": 20002,
    "Plan Width": 4,
    "Actual Startup Time": 11.546,
    "Actual Total Time": 14.277,
    "Actual Rows": 20002,
    "Actual Loops": 1,
    "Output": ["tt1.a"],
    "Group Key": ["tt1.a"],
    "Planned Partitions": 0,
    "HashAgg Batches": 1,
    "Peak Memory Usage": 1745,
    "Disk Usage": 0,
    "Shared Hit Blocks": 218,
    "Shared Read Blocks": 0,
    "Shared Dirtied Blocks": 0,
    "Shared Written Blocks": 0,
    "Local Hit Blocks": 0,
    "Local Read Blocks": 0,
    "Local Dirtied Blocks": 0,
    "Local Written Blocks": 0,
    "Temp Read Blocks": 0,
    "Temp Written Blocks": 0,
    "Plans": [
      {
        "Node Type": "Append",
        "Parent Relationship": "Outer",
        "Parallel Aware": false,
        "Async Capable": false,
        "Startup Cost": 0.00,
        "Total Cost": 518.03,
        "Plan Rows": 20002,
        "Plan Width": 4,
        "Actual Startup Time": 0.124,
        "Actual Total Time": 4.643,
        "Actual Rows": 20002,
        "Actual Loops": 1,
        "Shared Hit Blocks": 218,
        "Shared Read Blocks": 0,
        "Shared Dirtied Blocks": 0,
        "Shared Written Blocks": 0,
        "Local Hit Blocks": 0,
        "Local Read Blocks": 0,
        "Local Dirtied Blocks": 0,
        "Local Written Blocks": 0,
        "Temp Read Blocks": 0,
        "Temp Written Blocks": 0,
        "Subplans Removed": 0,
        "Plans": [
          {
            "Node Type": "Seq Scan",
            "Parent Relationship": "Member",
            "Parallel Aware": false,
            "Async Capable": false,
            "Relation Name": "tt1",
            "Schema": "public",
            "Alias": "tt1",
            "Startup Cost": 0.00,
            "Total Cost": 263.01,
            "Plan Rows": 10001,
            "Plan Width": 4,
            "Actual Startup Time": 0.123,
            "Actual Total Time": 1.680,
            "Actual Rows": 10001,
            "Actual Loops": 1,
            "Output": ["tt1.a"],
            "Shared Hit Blocks": 163,
            "Shared Read Blocks": 0,
            "Shared Dirtied Blocks": 0,
            "Shared Written Blocks": 0,
            "Local Hit Blocks": 0,
            "Local Read Blocks": 0,
            "Local Dirtied Blocks": 0,
            "Local Written Blocks": 0,
            "Temp Read Blocks": 0,
            "Temp Written Blocks": 0
          },
          {
            "Node Type": "Seq Scan",
            "Parent Relationship": "Member",
            "Parallel Aware": false,
            "Async Capable": false,
            "Relation Name": "tt2",
            "Schema": "public",
            "Alias": "tt2",
            "Startup Cost": 0.00,
            "Total Cost": 155.01,
            "Plan Rows": 10001,
            "Plan Width": 4,
            "Actual Startup Time": 0.007,
            "Actual Total Time": 1.603,
            "Actual Rows": 10001,
            "Actual Loops": 1,
            "Output": ["tt2.b"],
            "Shared Hit Blocks": 55,
            "Shared Read Blocks": 0,
            "Shared Dirtied Blocks": 0,
            "Shared Written Blocks": 0,
            "Local Hit Blocks": 0,
            "Local Read Blocks": 0,
            "Local Dirtied Blocks": 0,
            "Local Written Blocks": 0,
            "Temp Read Blocks": 0,
            "Temp Written Blocks": 0
          }
        ]
      }
    ]
  },
  "Query Identifier": -8872189582690592514,
  "Planning": {
    "Shared Hit Blocks": 0,
    "Shared Read Blocks": 0,
    "Shared Dirtied Blocks": 0,
    "Shared Written Blocks": 0,
    "Local Hit Blocks": 0,
    "Local Read Blocks": 0,
    "Local Dirtied Blocks": 0,
    "Local Written Blocks": 0,
    "Temp Read Blocks": 0,
    "Temp Written Blocks": 0
  },
  "Planning Time": 0.070,
  "Triggers": [
  ],
  "Execution Time": 15.368
}'),
(12, '###### Plan 12: GroupAggregate',
 '{
  "Plan": {
    "Node Type": "Aggregate",
    "Strategy": "Hashed",
    "Partial Mode": "Simple",
    "Parallel Aware": false,
    "Async Capable": false,
    "Startup Cost": 825.57,
    "Total Cost": 1003.71,
    "Plan Rows": 10001,
    "Plan Width": 12,
    "Actual Startup Time": 5.146,
    "Actual Total Time": 10.843,
    "Actual Rows": 10001,
    "Actual Loops": 1,
    "Output": ["sum(a)", "b"],
    "Group Key": ["tt1.b"],
    "Planned Partitions": 4,
    "HashAgg Batches": 21,
    "Peak Memory Usage": 297,
    "Disk Usage": 392,
    "Shared Hit Blocks": 163,
    "Shared Read Blocks": 0,
    "Shared Dirtied Blocks": 0,
    "Shared Written Blocks": 0,
    "Local Hit Blocks": 0,
    "Local Read Blocks": 0,
    "Local Dirtied Blocks": 0,
    "Local Written Blocks": 0,
    "Temp Read Blocks": 46,
    "Temp Written Blocks": 85,
    "Plans": [
      {
        "Node Type": "Seq Scan",
        "Parent Relationship": "Outer",
        "Parallel Aware": false,
        "Async Capable": false,
        "Relation Name": "tt1",
        "Schema": "public",
        "Alias": "tt1",
        "Startup Cost": 0.00,
        "Total Cost": 263.01,
        "Plan Rows": 10001,
        "Plan Width": 8,
        "Actual Startup Time": 0.133,
        "Actual Total Time": 1.146,
        "Actual Rows": 10001,
        "Actual Loops": 1,
        "Output": ["a", "b", "c"],
        "Shared Hit Blocks": 163,
        "Shared Read Blocks": 0,
        "Shared Dirtied Blocks": 0,
        "Shared Written Blocks": 0,
        "Local Hit Blocks": 0,
        "Local Read Blocks": 0,
        "Local Dirtied Blocks": 0,
        "Local Written Blocks": 0,
        "Temp Read Blocks": 0,
        "Temp Written Blocks": 0
      }
    ]
  },
  "Query Identifier": 6518315873774822179,
  "Planning": {
    "Shared Hit Blocks": 0,
    "Shared Read Blocks": 0,
    "Shared Dirtied Blocks": 0,
    "Shared Written Blocks": 0,
    "Local Hit Blocks": 0,
    "Local Read Blocks": 0,
    "Local Dirtied Blocks": 0,
    "Local Written Blocks": 0,
    "Temp Read Blocks": 0,
    "Temp Written Blocks": 0
  },
  "Planning Time": 0.050,
  "Triggers": [
  ],
  "Execution Time": 11.504
}'),
(13, '###### Plan 13: Group',
 '{
  "Plan": {
    "Node Type": "Aggregate",
    "Strategy": "Hashed",
    "Partial Mode": "Simple",
    "Parallel Aware": false,
    "Async Capable": false,
    "Startup Cost": 800.56,
    "Total Cost": 978.71,
    "Plan Rows": 10001,
    "Plan Width": 4,
    "Actual Startup Time": 4.862,
    "Actual Total Time": 8.969,
    "Actual Rows": 10001,
    "Actual Loops": 1,
    "Output": ["b"],
    "Group Key": ["tt1.b"],
    "Planned Partitions": 4,
    "HashAgg Batches": 5,
    "Peak Memory Usage": 249,
    "Disk Usage": 240,
    "Shared Hit Blocks": 163,
    "Shared Read Blocks": 0,
    "Shared Dirtied Blocks": 0,
    "Shared Written Blocks": 0,
    "Local Hit Blocks": 0,
    "Local Read Blocks": 0,
    "Local Dirtied Blocks": 0,
    "Local Written Blocks": 0,
    "Temp Read Blocks": 25,
    "Temp Written Blocks": 48,
    "Plans": [
      {
        "Node Type": "Seq Scan",
        "Parent Relationship": "Outer",
        "Parallel Aware": false,
        "Async Capable": false,
        "Relation Name": "tt1",
        "Schema": "public",
        "Alias": "tt1",
        "Startup Cost": 0.00,
        "Total Cost": 263.01,
        "Plan Rows": 10001,
        "Plan Width": 4,
        "Actual Startup Time": 0.102,
        "Actual Total Time": 1.136,
        "Actual Rows": 10001,
        "Actual Loops": 1,
        "Output": ["a", "b", "c"],
        "Shared Hit Blocks": 163,
        "Shared Read Blocks": 0,
        "Shared Dirtied Blocks": 0,
        "Shared Written Blocks": 0,
        "Local Hit Blocks": 0,
        "Local Read Blocks": 0,
        "Local Dirtied Blocks": 0,
        "Local Written Blocks": 0,
        "Temp Read Blocks": 0,
        "Temp Written Blocks": 0
      }
    ]
  },
  "Query Identifier": 1795826405131444635,
  "Planning": {
    "Shared Hit Blocks": 0,
    "Shared Read Blocks": 0,
    "Shared Dirtied Blocks": 0,
    "Shared Written Blocks": 0,
    "Local Hit Blocks": 0,
    "Local Read Blocks": 0,
    "Local Dirtied Blocks": 0,
    "Local Written Blocks": 0,
    "Temp Read Blocks": 0,
    "Temp Written Blocks": 0
  },
  "Planning Time": 0.038,
  "Triggers": [
  ],
  "Execution Time": 9.450
}'),
(14, '###### Plan 14: SetOp intersect, SubqueryScan',
 E'{
  "Plan": {
    "Node Type": "Sort",
    "Parallel Aware": false,
    "Async Capable": false,
    "Startup Cost": 1432.51,
    "Total Cost": 1457.52,
    "Plan Rows": 10001,
    "Plan Width": 8,
    "Actual Startup Time": 11.237,
    "Actual Total Time": 11.239,
    "Actual Rows": 0,
    "Actual Loops": 1,
    "Output": ["\\"*SELECT* 1\\".a", "(0)"],
    "Sort Key": ["\\"*SELECT* 1\\".a"],
    "Sort Method": "quicksort",
    "Sort Space Used": 25,
    "Sort Space Type": "Memory",
    "Shared Hit Blocks": 218,
    "Shared Read Blocks": 0,
    "Shared Dirtied Blocks": 0,
    "Shared Written Blocks": 0,
    "Local Hit Blocks": 0,
    "Local Read Blocks": 0,
    "Local Dirtied Blocks": 0,
    "Local Written Blocks": 0,
    "Temp Read Blocks": 0,
    "Temp Written Blocks": 0,
    "Plans": [
      {
        "Node Type": "SetOp",
        "Strategy": "Hashed",
        "Parent Relationship": "Outer",
        "Parallel Aware": false,
        "Async Capable": false,
        "Command": "Intersect",
        "Startup Cost": 0.00,
        "Total Cost": 768.05,
        "Plan Rows": 10001,
        "Plan Width": 8,
        "Actual Startup Time": 11.231,
        "Actual Total Time": 11.232,
        "Actual Rows": 0,
        "Actual Loops": 1,
        "Output": ["\\"*SELECT* 1\\".a", "(0)"],
        "Shared Hit Blocks": 218,
        "Shared Read Blocks": 0,
        "Shared Dirtied Blocks": 0,
        "Shared Written Blocks": 0,
        "Local Hit Blocks": 0,
        "Local Read Blocks": 0,
        "Local Dirtied Blocks": 0,
        "Local Written Blocks": 0,
        "Temp Read Blocks": 0,
        "Temp Written Blocks": 0,
        "Plans": [
          {
            "Node Type": "Append",
            "Parent Relationship": "Outer",
            "Parallel Aware": false,
            "Async Capable": false,
            "Startup Cost": 0.00,
            "Total Cost": 718.05,
            "Plan Rows": 20002,
            "Plan Width": 8,
            "Actual Startup Time": 0.109,
            "Actual Total Time": 7.190,
            "Actual Rows": 20002,
            "Actual Loops": 1,
            "Shared Hit Blocks": 218,
            "Shared Read Blocks": 0,
            "Shared Dirtied Blocks": 0,
            "Shared Written Blocks": 0,
            "Local Hit Blocks": 0,
            "Local Read Blocks": 0,
            "Local Dirtied Blocks": 0,
            "Local Written Blocks": 0,
            "Temp Read Blocks": 0,
            "Temp Written Blocks": 0,
            "Subplans Removed": 0,
            "Plans": [
              {
                "Node Type": "Subquery Scan",
                "Parent Relationship": "Member",
                "Parallel Aware": false,
                "Async Capable": false,
                "Alias": "*SELECT* 1",
                "Startup Cost": 0.00,
                "Total Cost": 363.02,
                "Plan Rows": 10001,
                "Plan Width": 8,
                "Actual Startup Time": 0.109,
                "Actual Total Time": 2.768,
                "Actual Rows": 10001,
                "Actual Loops": 1,
                "Output": ["\\"*SELECT* 1\\".a", "0"],
                "Shared Hit Blocks": 163,
                "Shared Read Blocks": 0,
                "Shared Dirtied Blocks": 0,
                "Shared Written Blocks": 0,
                "Local Hit Blocks": 0,
                "Local Read Blocks": 0,
                "Local Dirtied Blocks": 0,
                "Local Written Blocks": 0,
                "Temp Read Blocks": 0,
                "Temp Written Blocks": 0,
                "Plans": [
                  {
                    "Node Type": "Seq Scan",
                    "Parent Relationship": "Subquery",
                    "Parallel Aware": false,
                    "Async Capable": false,
                    "Relation Name": "tt1",
                    "Schema": "public",
                    "Alias": "tt1",
                    "Startup Cost": 0.00,
                    "Total Cost": 263.01,
                    "Plan Rows": 10001,
                    "Plan Width": 4,
                    "Actual Startup Time": 0.107,
                    "Actual Total Time": 1.558,
                    "Actual Rows": 10001,
                    "Actual Loops": 1,
                    "Output": ["tt1.a"],
                    "Shared Hit Blocks": 163,
                    "Shared Read Blocks": 0,
                    "Shared Dirtied Blocks": 0,
                    "Shared Written Blocks": 0,
                    "Local Hit Blocks": 0,
                    "Local Read Blocks": 0,
                    "Local Dirtied Blocks": 0,
                    "Local Written Blocks": 0,
                    "Temp Read Blocks": 0,
                    "Temp Written Blocks": 0
                  }
                ]
              },
              {
                "Node Type": "Subquery Scan",
                "Parent Relationship": "Member",
                "Parallel Aware": false,
                "Async Capable": false,
                "Alias": "*SELECT* 2",
                "Startup Cost": 0.00,
                "Total Cost": 255.02,
                "Plan Rows": 10001,
                "Plan Width": 8,
                "Actual Startup Time": 0.009,
                "Actual Total Time": 2.737,
                "Actual Rows": 10001,
                "Actual Loops": 1,
                "Output": ["\\"*SELECT* 2\\".b", "1"],
                "Shared Hit Blocks": 55,
                "Shared Read Blocks": 0,
                "Shared Dirtied Blocks": 0,
                "Shared Written Blocks": 0,
                "Local Hit Blocks": 0,
                "Local Read Blocks": 0,
                "Local Dirtied Blocks": 0,
                "Local Written Blocks": 0,
                "Temp Read Blocks": 0,
                "Temp Written Blocks": 0,
                "Plans": [
                  {
                    "Node Type": "Seq Scan",
                    "Parent Relationship": "Subquery",
                    "Parallel Aware": false,
                    "Async Capable": false,
                    "Relation Name": "tt2",
                    "Schema": "public",
                    "Alias": "tt2",
                    "Startup Cost": 0.00,
                    "Total Cost": 155.01,
                    "Plan Rows": 10001,
                    "Plan Width": 4,
                    "Actual Startup Time": 0.008,
                    "Actual Total Time": 1.570,
                    "Actual Rows": 10001,
                    "Actual Loops": 1,
                    "Output": ["tt2.b"],
                    "Shared Hit Blocks": 55,
                    "Shared Read Blocks": 0,
                    "Shared Dirtied Blocks": 0,
                    "Shared Written Blocks": 0,
                    "Local Hit Blocks": 0,
                    "Local Read Blocks": 0,
                    "Local Dirtied Blocks": 0,
                    "Local Written Blocks": 0,
                    "Temp Read Blocks": 0,
                    "Temp Written Blocks": 0
                  }
                ]
              }
            ]
          }
        ]
      }
    ]
  },
  "Query Identifier": -1845361595063486082,
  "Planning": {
    "Shared Hit Blocks": 0,
    "Shared Read Blocks": 0,
    "Shared Dirtied Blocks": 0,
    "Shared Written Blocks": 0,
    "Local Hit Blocks": 0,
    "Local Read Blocks": 0,
    "Local Dirtied Blocks": 0,
    "Local Written Blocks": 0,
    "Temp Read Blocks": 0,
    "Temp Written Blocks": 0
  },
  "Planning Time": 0.070,
  "Triggers": [
  ],
  "Execution Time": 11.867
}'),
(15, '###### Plan 15: Sorted SetOp, Sort on Disk',
 E'{
  "Plan": {
    "Node Type": "Sort",
    "Parallel Aware": false,
    "Async Capable": false,
    "Startup Cost": 1572.51,
    "Total Cost": 1597.52,
    "Plan Rows": 10001,
    "Plan Width": 8,
    "Actual Startup Time": 10.993,
    "Actual Total Time": 10.994,
    "Actual Rows": 0,
    "Actual Loops": 1,
    "Output": ["\\"*SELECT* 1\\".a", "(0)"],
    "Sort Key": ["\\"*SELECT* 1\\".a"],
    "Sort Method": "quicksort",
    "Sort Space Used": 25,
    "Sort Space Type": "Memory",
    "Shared Hit Blocks": 218,
    "Shared Read Blocks": 0,
    "Shared Dirtied Blocks": 0,
    "Shared Written Blocks": 0,
    "Local Hit Blocks": 0,
    "Local Read Blocks": 0,
    "Local Dirtied Blocks": 0,
    "Local Written Blocks": 0,
    "Temp Read Blocks": 0,
    "Temp Written Blocks": 0,
    "Plans": [
      {
        "Node Type": "SetOp",
        "Strategy": "Hashed",
        "Parent Relationship": "Outer",
        "Parallel Aware": false,
        "Async Capable": false,
        "Command": "Intersect",
        "Startup Cost": 0.00,
        "Total Cost": 768.05,
        "Plan Rows": 10001,
        "Plan Width": 8,
        "Actual Startup Time": 10.989,
        "Actual Total Time": 10.991,
        "Actual Rows": 0,
        "Actual Loops": 1,
        "Output": ["\\"*SELECT* 1\\".a", "(0)"],
        "Shared Hit Blocks": 218,
        "Shared Read Blocks": 0,
        "Shared Dirtied Blocks": 0,
        "Shared Written Blocks": 0,
        "Local Hit Blocks": 0,
        "Local Read Blocks": 0,
        "Local Dirtied Blocks": 0,
        "Local Written Blocks": 0,
        "Temp Read Blocks": 0,
        "Temp Written Blocks": 0,
        "Plans": [
          {
            "Node Type": "Append",
            "Parent Relationship": "Outer",
            "Parallel Aware": false,
            "Async Capable": false,
            "Startup Cost": 0.00,
            "Total Cost": 718.05,
            "Plan Rows": 20002,
            "Plan Width": 8,
            "Actual Startup Time": 0.100,
            "Actual Total Time": 7.168,
            "Actual Rows": 20002,
            "Actual Loops": 1,
            "Shared Hit Blocks": 218,
            "Shared Read Blocks": 0,
            "Shared Dirtied Blocks": 0,
            "Shared Written Blocks": 0,
            "Local Hit Blocks": 0,
            "Local Read Blocks": 0,
            "Local Dirtied Blocks": 0,
            "Local Written Blocks": 0,
            "Temp Read Blocks": 0,
            "Temp Written Blocks": 0,
            "Subplans Removed": 0,
            "Plans": [
              {
                "Node Type": "Subquery Scan",
                "Parent Relationship": "Member",
                "Parallel Aware": false,
                "Async Capable": false,
                "Alias": "*SELECT* 1",
                "Startup Cost": 0.00,
                "Total Cost": 363.02,
                "Plan Rows": 10001,
                "Plan Width": 8,
                "Actual Startup Time": 0.099,
                "Actual Total Time": 2.793,
                "Actual Rows": 10001,
                "Actual Loops": 1,
                "Output": ["\\"*SELECT* 1\\".a", "0"],
                "Shared Hit Blocks": 163,
                "Shared Read Blocks": 0,
                "Shared Dirtied Blocks": 0,
                "Shared Written Blocks": 0,
                "Local Hit Blocks": 0,
                "Local Read Blocks": 0,
                "Local Dirtied Blocks": 0,
                "Local Written Blocks": 0,
                "Temp Read Blocks": 0,
                "Temp Written Blocks": 0,
                "Plans": [
                  {
                    "Node Type": "Seq Scan",
                    "Parent Relationship": "Subquery",
                    "Parallel Aware": false,
                    "Async Capable": false,
                    "Relation Name": "tt1",
                    "Schema": "public",
                    "Alias": "tt1",
                    "Startup Cost": 0.00,
                    "Total Cost": 263.01,
                    "Plan Rows": 10001,
                    "Plan Width": 4,
                    "Actual Startup Time": 0.098,
                    "Actual Total Time": 1.608,
                    "Actual Rows": 10001,
                    "Actual Loops": 1,
                    "Output": ["tt1.a"],
                    "Shared Hit Blocks": 163,
                    "Shared Read Blocks": 0,
                    "Shared Dirtied Blocks": 0,
                    "Shared Written Blocks": 0,
                    "Local Hit Blocks": 0,
                    "Local Read Blocks": 0,
                    "Local Dirtied Blocks": 0,
                    "Local Written Blocks": 0,
                    "Temp Read Blocks": 0,
                    "Temp Written Blocks": 0
                  }
                ]
              },
              {
                "Node Type": "Subquery Scan",
                "Parent Relationship": "Member",
                "Parallel Aware": false,
                "Async Capable": false,
                "Alias": "*SELECT* 2",
                "Startup Cost": 0.00,
                "Total Cost": 255.02,
                "Plan Rows": 10001,
                "Plan Width": 8,
                "Actual Startup Time": 0.009,
                "Actual Total Time": 2.653,
                "Actual Rows": 10001,
                "Actual Loops": 1,
                "Output": ["\\"*SELECT* 2\\".b", "1"],
                "Shared Hit Blocks": 55,
                "Shared Read Blocks": 0,
                "Shared Dirtied Blocks": 0,
                "Shared Written Blocks": 0,
                "Local Hit Blocks": 0,
                "Local Read Blocks": 0,
                "Local Dirtied Blocks": 0,
                "Local Written Blocks": 0,
                "Temp Read Blocks": 0,
                "Temp Written Blocks": 0,
                "Plans": [
                  {
                    "Node Type": "Seq Scan",
                    "Parent Relationship": "Subquery",
                    "Parallel Aware": false,
                    "Async Capable": false,
                    "Relation Name": "tt2",
                    "Schema": "public",
                    "Alias": "tt2",
                    "Startup Cost": 0.00,
                    "Total Cost": 155.01,
                    "Plan Rows": 10001,
                    "Plan Width": 4,
                    "Actual Startup Time": 0.008,
                    "Actual Total Time": 1.493,
                    "Actual Rows": 10001,
                    "Actual Loops": 1,
                    "Output": ["tt2.b"],
                    "Shared Hit Blocks": 55,
                    "Shared Read Blocks": 0,
                    "Shared Dirtied Blocks": 0,
                    "Shared Written Blocks": 0,
                    "Local Hit Blocks": 0,
                    "Local Read Blocks": 0,
                    "Local Dirtied Blocks": 0,
                    "Local Written Blocks": 0,
                    "Temp Read Blocks": 0,
                    "Temp Written Blocks": 0
                  }
                ]
              }
            ]
          }
        ]
      }
    ]
  },
  "Query Identifier": -1845361595063486082,
  "Planning": {
    "Shared Hit Blocks": 0,
    "Shared Read Blocks": 0,
    "Shared Dirtied Blocks": 0,
    "Shared Written Blocks": 0,
    "Local Hit Blocks": 0,
    "Local Read Blocks": 0,
    "Local Dirtied Blocks": 0,
    "Local Written Blocks": 0,
    "Temp Read Blocks": 0,
    "Temp Written Blocks": 0
  },
  "Planning Time": 0.060,
  "Triggers": [
  ],
  "Execution Time": 11.573
}'),
(16, '###### Plan 16: HashSetOp intersect All, SubqueryScan',
 E'{
  "Plan": {
    "Node Type": "Sort",
    "Parallel Aware": false,
    "Async Capable": false,
    "Startup Cost": 1432.51,
    "Total Cost": 1457.52,
    "Plan Rows": 10001,
    "Plan Width": 8,
    "Actual Startup Time": 11.020,
    "Actual Total Time": 11.021,
    "Actual Rows": 0,
    "Actual Loops": 1,
    "Output": ["\\"*SELECT* 1\\".a", "(0)"],
    "Sort Key": ["\\"*SELECT* 1\\".a"],
    "Sort Method": "quicksort",
    "Sort Space Used": 25,
    "Sort Space Type": "Memory",
    "Shared Hit Blocks": 218,
    "Shared Read Blocks": 0,
    "Shared Dirtied Blocks": 0,
    "Shared Written Blocks": 0,
    "Local Hit Blocks": 0,
    "Local Read Blocks": 0,
    "Local Dirtied Blocks": 0,
    "Local Written Blocks": 0,
    "Temp Read Blocks": 0,
    "Temp Written Blocks": 0,
    "Plans": [
      {
        "Node Type": "SetOp",
        "Strategy": "Hashed",
        "Parent Relationship": "Outer",
        "Parallel Aware": false,
        "Async Capable": false,
        "Command": "Intersect All",
        "Startup Cost": 0.00,
        "Total Cost": 768.05,
        "Plan Rows": 10001,
        "Plan Width": 8,
        "Actual Startup Time": 11.017,
        "Actual Total Time": 11.018,
        "Actual Rows": 0,
        "Actual Loops": 1,
        "Output": ["\\"*SELECT* 1\\".a", "(0)"],
        "Shared Hit Blocks": 218,
        "Shared Read Blocks": 0,
        "Shared Dirtied Blocks": 0,
        "Shared Written Blocks": 0,
        "Local Hit Blocks": 0,
        "Local Read Blocks": 0,
        "Local Dirtied Blocks": 0,
        "Local Written Blocks": 0,
        "Temp Read Blocks": 0,
        "Temp Written Blocks": 0,
        "Plans": [
          {
            "Node Type": "Append",
            "Parent Relationship": "Outer",
            "Parallel Aware": false,
            "Async Capable": false,
            "Startup Cost": 0.00,
            "Total Cost": 718.05,
            "Plan Rows": 20002,
            "Plan Width": 8,
            "Actual Startup Time": 0.099,
            "Actual Total Time": 7.184,
            "Actual Rows": 20002,
            "Actual Loops": 1,
            "Shared Hit Blocks": 218,
            "Shared Read Blocks": 0,
            "Shared Dirtied Blocks": 0,
            "Shared Written Blocks": 0,
            "Local Hit Blocks": 0,
            "Local Read Blocks": 0,
            "Local Dirtied Blocks": 0,
            "Local Written Blocks": 0,
            "Temp Read Blocks": 0,
            "Temp Written Blocks": 0,
            "Subplans Removed": 0,
            "Plans": [
              {
                "Node Type": "Subquery Scan",
                "Parent Relationship": "Member",
                "Parallel Aware": false,
                "Async Capable": false,
                "Alias": "*SELECT* 1",
                "Startup Cost": 0.00,
                "Total Cost": 363.02,
                "Plan Rows": 10001,
                "Plan Width": 8,
                "Actual Startup Time": 0.098,
                "Actual Total Time": 2.811,
                "Actual Rows": 10001,
                "Actual Loops": 1,
                "Output": ["\\"*SELECT* 1\\".a", "0"],
                "Shared Hit Blocks": 163,
                "Shared Read Blocks": 0,
                "Shared Dirtied Blocks": 0,
                "Shared Written Blocks": 0,
                "Local Hit Blocks": 0,
                "Local Read Blocks": 0,
                "Local Dirtied Blocks": 0,
                "Local Written Blocks": 0,
                "Temp Read Blocks": 0,
                "Temp Written Blocks": 0,
                "Plans": [
                  {
                    "Node Type": "Seq Scan",
                    "Parent Relationship": "Subquery",
                    "Parallel Aware": false,
                    "Async Capable": false,
                    "Relation Name": "tt1",
                    "Schema": "public",
                    "Alias": "tt1",
                    "Startup Cost": 0.00,
                    "Total Cost": 263.01,
                    "Plan Rows": 10001,
                    "Plan Width": 4,
                    "Actual Startup Time": 0.097,
                    "Actual Total Time": 1.610,
                    "Actual Rows": 10001,
                    "Actual Loops": 1,
                    "Output": ["tt1.a"],
                    "Shared Hit Blocks": 163,
                    "Shared Read Blocks": 0,
                    "Shared Dirtied Blocks": 0,
                    "Shared Written Blocks": 0,
                    "Local Hit Blocks": 0,
                    "Local Read Blocks": 0,
                    "Local Dirtied Blocks": 0,
                    "Local Written Blocks": 0,
                    "Temp Read Blocks": 0,
                    "Temp Written Blocks": 0
                  }
                ]
              },
              {
                "Node Type": "Subquery Scan",
                "Parent Relationship": "Member",
                "Parallel Aware": false,
                "Async Capable": false,
                "Alias": "*SELECT* 2",
                "Startup Cost": 0.00,
                "Total Cost": 255.02,
                "Plan Rows": 10001,
                "Plan Width": 8,
                "Actual Startup Time": 0.008,
                "Actual Total Time": 2.604,
                "Actual Rows": 10001,
                "Actual Loops": 1,
                "Output": ["\\"*SELECT* 2\\".b", "1"],
                "Shared Hit Blocks": 55,
                "Shared Read Blocks": 0,
                "Shared Dirtied Blocks": 0,
                "Shared Written Blocks": 0,
                "Local Hit Blocks": 0,
                "Local Read Blocks": 0,
                "Local Dirtied Blocks": 0,
                "Local Written Blocks": 0,
                "Temp Read Blocks": 0,
                "Temp Written Blocks": 0,
                "Plans": [
                  {
                    "Node Type": "Seq Scan",
                    "Parent Relationship": "Subquery",
                    "Parallel Aware": false,
                    "Async Capable": false,
                    "Relation Name": "tt2",
                    "Schema": "public",
                    "Alias": "tt2",
                    "Startup Cost": 0.00,
                    "Total Cost": 155.01,
                    "Plan Rows": 10001,
                    "Plan Width": 4,
                    "Actual Startup Time": 0.008,
                    "Actual Total Time": 1.476,
                    "Actual Rows": 10001,
                    "Actual Loops": 1,
                    "Output": ["tt2.b"],
                    "Shared Hit Blocks": 55,
                    "Shared Read Blocks": 0,
                    "Shared Dirtied Blocks": 0,
                    "Shared Written Blocks": 0,
                    "Local Hit Blocks": 0,
                    "Local Read Blocks": 0,
                    "Local Dirtied Blocks": 0,
                    "Local Written Blocks": 0,
                    "Temp Read Blocks": 0,
                    "Temp Written Blocks": 0
                  }
                ]
              }
            ]
          }
        ]
      }
    ]
  },
  "Query Identifier": -277779895575701989,
  "Planning": {
    "Shared Hit Blocks": 0,
    "Shared Read Blocks": 0,
    "Shared Dirtied Blocks": 0,
    "Shared Written Blocks": 0,
    "Local Hit Blocks": 0,
    "Local Read Blocks": 0,
    "Local Dirtied Blocks": 0,
    "Local Written Blocks": 0,
    "Temp Read Blocks": 0,
    "Temp Written Blocks": 0
  },
  "Planning Time": 0.054,
  "Triggers": [
  ],
  "Execution Time": 11.642
}'),
(17, '###### Plan 17: HashSetOp except, SubqueryScan',
 E'{
  "Plan": {
    "Node Type": "Sort",
    "Parallel Aware": false,
    "Async Capable": false,
    "Startup Cost": 1432.51,
    "Total Cost": 1457.52,
    "Plan Rows": 10001,
    "Plan Width": 8,
    "Actual Startup Time": 13.983,
    "Actual Total Time": 14.621,
    "Actual Rows": 10001,
    "Actual Loops": 1,
    "Output": ["\\"*SELECT* 1\\".a", "(0)"],
    "Sort Key": ["\\"*SELECT* 1\\".a"],
    "Sort Method": "quicksort",
    "Sort Space Used": 811,
    "Sort Space Type": "Memory",
    "Shared Hit Blocks": 218,
    "Shared Read Blocks": 0,
    "Shared Dirtied Blocks": 0,
    "Shared Written Blocks": 0,
    "Local Hit Blocks": 0,
    "Local Read Blocks": 0,
    "Local Dirtied Blocks": 0,
    "Local Written Blocks": 0,
    "Temp Read Blocks": 0,
    "Temp Written Blocks": 0,
    "Plans": [
      {
        "Node Type": "SetOp",
        "Strategy": "Hashed",
        "Parent Relationship": "Outer",
        "Parallel Aware": false,
        "Async Capable": false,
        "Command": "Except",
        "Startup Cost": 0.00,
        "Total Cost": 768.05,
        "Plan Rows": 10001,
        "Plan Width": 8,
        "Actual Startup Time": 10.767,
        "Actual Total Time": 11.402,
        "Actual Rows": 10001,
        "Actual Loops": 1,
        "Output": ["\\"*SELECT* 1\\".a", "(0)"],
        "Shared Hit Blocks": 218,
        "Shared Read Blocks": 0,
        "Shared Dirtied Blocks": 0,
        "Shared Written Blocks": 0,
        "Local Hit Blocks": 0,
        "Local Read Blocks": 0,
        "Local Dirtied Blocks": 0,
        "Local Written Blocks": 0,
        "Temp Read Blocks": 0,
        "Temp Written Blocks": 0,
        "Plans": [
          {
            "Node Type": "Append",
            "Parent Relationship": "Outer",
            "Parallel Aware": false,
            "Async Capable": false,
            "Startup Cost": 0.00,
            "Total Cost": 718.05,
            "Plan Rows": 20002,
            "Plan Width": 8,
            "Actual Startup Time": 0.103,
            "Actual Total Time": 7.201,
            "Actual Rows": 20002,
            "Actual Loops": 1,
            "Shared Hit Blocks": 218,
            "Shared Read Blocks": 0,
            "Shared Dirtied Blocks": 0,
            "Shared Written Blocks": 0,
            "Local Hit Blocks": 0,
            "Local Read Blocks": 0,
            "Local Dirtied Blocks": 0,
            "Local Written Blocks": 0,
            "Temp Read Blocks": 0,
            "Temp Written Blocks": 0,
            "Subplans Removed": 0,
            "Plans": [
              {
                "Node Type": "Subquery Scan",
                "Parent Relationship": "Member",
                "Parallel Aware": false,
                "Async Capable": false,
                "Alias": "*SELECT* 1",
                "Startup Cost": 0.00,
                "Total Cost": 363.02,
                "Plan Rows": 10001,
                "Plan Width": 8,
                "Actual Startup Time": 0.103,
                "Actual Total Time": 2.898,
                "Actual Rows": 10001,
                "Actual Loops": 1,
                "Output": ["\\"*SELECT* 1\\".a", "0"],
                "Shared Hit Blocks": 163,
                "Shared Read Blocks": 0,
                "Shared Dirtied Blocks": 0,
                "Shared Written Blocks": 0,
                "Local Hit Blocks": 0,
                "Local Read Blocks": 0,
                "Local Dirtied Blocks": 0,
                "Local Written Blocks": 0,
                "Temp Read Blocks": 0,
                "Temp Written Blocks": 0,
                "Plans": [
                  {
                    "Node Type": "Seq Scan",
                    "Parent Relationship": "Subquery",
                    "Parallel Aware": false,
                    "Async Capable": false,
                    "Relation Name": "tt1",
                    "Schema": "public",
                    "Alias": "tt1",
                    "Startup Cost": 0.00,
                    "Total Cost": 263.01,
                    "Plan Rows": 10001,
                    "Plan Width": 4,
                    "Actual Startup Time": 0.102,
                    "Actual Total Time": 1.624,
                    "Actual Rows": 10001,
                    "Actual Loops": 1,
                    "Output": ["tt1.a"],
                    "Shared Hit Blocks": 163,
                    "Shared Read Blocks": 0,
                    "Shared Dirtied Blocks": 0,
                    "Shared Written Blocks": 0,
                    "Local Hit Blocks": 0,
                    "Local Read Blocks": 0,
                    "Local Dirtied Blocks": 0,
                    "Local Written Blocks": 0,
                    "Temp Read Blocks": 0,
                    "Temp Written Blocks": 0
                  }
                ]
              },
              {
                "Node Type": "Subquery Scan",
                "Parent Relationship": "Member",
                "Parallel Aware": false,
                "Async Capable": false,
                "Alias": "*SELECT* 2",
                "Startup Cost": 0.00,
                "Total Cost": 255.02,
                "Plan Rows": 10001,
                "Plan Width": 8,
                "Actual Startup Time": 0.008,
                "Actual Total Time": 2.622,
                "Actual Rows": 10001,
                "Actual Loops": 1,
                "Output": ["\\"*SELECT* 2\\".b", "1"],
                "Shared Hit Blocks": 55,
                "Shared Read Blocks": 0,
                "Shared Dirtied Blocks": 0,
                "Shared Written Blocks": 0,
                "Local Hit Blocks": 0,
                "Local Read Blocks": 0,
                "Local Dirtied Blocks": 0,
                "Local Written Blocks": 0,
                "Temp Read Blocks": 0,
                "Temp Written Blocks": 0,
                "Plans": [
                  {
                    "Node Type": "Seq Scan",
                    "Parent Relationship": "Subquery",
                    "Parallel Aware": false,
                    "Async Capable": false,
                    "Relation Name": "tt2",
                    "Schema": "public",
                    "Alias": "tt2",
                    "Startup Cost": 0.00,
                    "Total Cost": 155.01,
                    "Plan Rows": 10001,
                    "Plan Width": 4,
                    "Actual Startup Time": 0.007,
                    "Actual Total Time": 1.475,
                    "Actual Rows": 10001,
                    "Actual Loops": 1,
                    "Output": ["tt2.b"],
                    "Shared Hit Blocks": 55,
                    "Shared Read Blocks": 0,
                    "Shared Dirtied Blocks": 0,
                    "Shared Written Blocks": 0,
                    "Local Hit Blocks": 0,
                    "Local Read Blocks": 0,
                    "Local Dirtied Blocks": 0,
                    "Local Written Blocks": 0,
                    "Temp Read Blocks": 0,
                    "Temp Written Blocks": 0
                  }
                ]
              }
            ]
          }
        ]
      }
    ]
  },
  "Query Identifier": -8475437809580394688,
  "Planning": {
    "Shared Hit Blocks": 0,
    "Shared Read Blocks": 0,
    "Shared Dirtied Blocks": 0,
    "Shared Written Blocks": 0,
    "Local Hit Blocks": 0,
    "Local Read Blocks": 0,
    "Local Dirtied Blocks": 0,
    "Local Written Blocks": 0,
    "Temp Read Blocks": 0,
    "Temp Written Blocks": 0
  },
  "Planning Time": 0.061,
  "Triggers": [
  ],
  "Execution Time": 16.227
}'),
(18, '###### Plan 18: HashSetOp except all, SubqueryScan',
 E'{
  "Plan": {
    "Node Type": "Sort",
    "Parallel Aware": false,
    "Async Capable": false,
    "Startup Cost": 1432.51,
    "Total Cost": 1457.52,
    "Plan Rows": 10001,
    "Plan Width": 8,
    "Actual Startup Time": 14.113,
    "Actual Total Time": 14.701,
    "Actual Rows": 10001,
    "Actual Loops": 1,
    "Output": ["\\"*SELECT* 1\\".a", "(0)"],
    "Sort Key": ["\\"*SELECT* 1\\".a"],
    "Sort Method": "quicksort",
    "Sort Space Used": 811,
    "Sort Space Type": "Memory",
    "Shared Hit Blocks": 218,
    "Shared Read Blocks": 0,
    "Shared Dirtied Blocks": 0,
    "Shared Written Blocks": 0,
    "Local Hit Blocks": 0,
    "Local Read Blocks": 0,
    "Local Dirtied Blocks": 0,
    "Local Written Blocks": 0,
    "Temp Read Blocks": 0,
    "Temp Written Blocks": 0,
    "Plans": [
      {
        "Node Type": "SetOp",
        "Strategy": "Hashed",
        "Parent Relationship": "Outer",
        "Parallel Aware": false,
        "Async Capable": false,
        "Command": "Except All",
        "Startup Cost": 0.00,
        "Total Cost": 768.05,
        "Plan Rows": 10001,
        "Plan Width": 8,
        "Actual Startup Time": 10.881,
        "Actual Total Time": 11.528,
        "Actual Rows": 10001,
        "Actual Loops": 1,
        "Output": ["\\"*SELECT* 1\\".a", "(0)"],
        "Shared Hit Blocks": 218,
        "Shared Read Blocks": 0,
        "Shared Dirtied Blocks": 0,
        "Shared Written Blocks": 0,
        "Local Hit Blocks": 0,
        "Local Read Blocks": 0,
        "Local Dirtied Blocks": 0,
        "Local Written Blocks": 0,
        "Temp Read Blocks": 0,
        "Temp Written Blocks": 0,
        "Plans": [
          {
            "Node Type": "Append",
            "Parent Relationship": "Outer",
            "Parallel Aware": false,
            "Async Capable": false,
            "Startup Cost": 0.00,
            "Total Cost": 718.05,
            "Plan Rows": 20002,
            "Plan Width": 8,
            "Actual Startup Time": 0.111,
            "Actual Total Time": 7.268,
            "Actual Rows": 20002,
            "Actual Loops": 1,
            "Shared Hit Blocks": 218,
            "Shared Read Blocks": 0,
            "Shared Dirtied Blocks": 0,
            "Shared Written Blocks": 0,
            "Local Hit Blocks": 0,
            "Local Read Blocks": 0,
            "Local Dirtied Blocks": 0,
            "Local Written Blocks": 0,
            "Temp Read Blocks": 0,
            "Temp Written Blocks": 0,
            "Subplans Removed": 0,
            "Plans": [
              {
                "Node Type": "Subquery Scan",
                "Parent Relationship": "Member",
                "Parallel Aware": false,
                "Async Capable": false,
                "Alias": "*SELECT* 1",
                "Startup Cost": 0.00,
                "Total Cost": 363.02,
                "Plan Rows": 10001,
                "Plan Width": 8,
                "Actual Startup Time": 0.111,
                "Actual Total Time": 2.831,
                "Actual Rows": 10001,
                "Actual Loops": 1,
                "Output": ["\\"*SELECT* 1\\".a", "0"],
                "Shared Hit Blocks": 163,
                "Shared Read Blocks": 0,
                "Shared Dirtied Blocks": 0,
                "Shared Written Blocks": 0,
                "Local Hit Blocks": 0,
                "Local Read Blocks": 0,
                "Local Dirtied Blocks": 0,
                "Local Written Blocks": 0,
                "Temp Read Blocks": 0,
                "Temp Written Blocks": 0,
                "Plans": [
                  {
                    "Node Type": "Seq Scan",
                    "Parent Relationship": "Subquery",
                    "Parallel Aware": false,
                    "Async Capable": false,
                    "Relation Name": "tt1",
                    "Schema": "public",
                    "Alias": "tt1",
                    "Startup Cost": 0.00,
                    "Total Cost": 263.01,
                    "Plan Rows": 10001,
                    "Plan Width": 4,
                    "Actual Startup Time": 0.110,
                    "Actual Total Time": 1.617,
                    "Actual Rows": 10001,
                    "Actual Loops": 1,
                    "Output": ["tt1.a"],
                    "Shared Hit Blocks": 163,
                    "Shared Read Blocks": 0,
                    "Shared Dirtied Blocks": 0,
                    "Shared Written Blocks": 0,
                    "Local Hit Blocks": 0,
                    "Local Read Blocks": 0,
                    "Local Dirtied Blocks": 0,
                    "Local Written Blocks": 0,
                    "Temp Read Blocks": 0,
                    "Temp Written Blocks": 0
                  }
                ]
              },
              {
                "Node Type": "Subquery Scan",
                "Parent Relationship": "Member",
                "Parallel Aware": false,
                "Async Capable": false,
                "Alias": "*SELECT* 2",
                "Startup Cost": 0.00,
                "Total Cost": 255.02,
                "Plan Rows": 10001,
                "Plan Width": 8,
                "Actual Startup Time": 0.008,
                "Actual Total Time": 2.740,
                "Actual Rows": 10001,
                "Actual Loops": 1,
                "Output": ["\\"*SELECT* 2\\".b", "1"],
                "Shared Hit Blocks": 55,
                "Shared Read Blocks": 0,
                "Shared Dirtied Blocks": 0,
                "Shared Written Blocks": 0,
                "Local Hit Blocks": 0,
                "Local Read Blocks": 0,
                "Local Dirtied Blocks": 0,
                "Local Written Blocks": 0,
                "Temp Read Blocks": 0,
                "Temp Written Blocks": 0,
                "Plans": [
                  {
                    "Node Type": "Seq Scan",
                    "Parent Relationship": "Subquery",
                    "Parallel Aware": false,
                    "Async Capable": false,
                    "Relation Name": "tt2",
                    "Schema": "public",
                    "Alias": "tt2",
                    "Startup Cost": 0.00,
                    "Total Cost": 155.01,
                    "Plan Rows": 10001,
                    "Plan Width": 4,
                    "Actual Startup Time": 0.007,
                    "Actual Total Time": 1.552,
                    "Actual Rows": 10001,
                    "Actual Loops": 1,
                    "Output": ["tt2.b"],
                    "Shared Hit Blocks": 55,
                    "Shared Read Blocks": 0,
                    "Shared Dirtied Blocks": 0,
                    "Shared Written Blocks": 0,
                    "Local Hit Blocks": 0,
                    "Local Read Blocks": 0,
                    "Local Dirtied Blocks": 0,
                    "Local Written Blocks": 0,
                    "Temp Read Blocks": 0,
                    "Temp Written Blocks": 0
                  }
                ]
              }
            ]
          }
        ]
      }
    ]
  },
  "Query Identifier": 7206519043208595474,
  "Planning": {
    "Shared Hit Blocks": 0,
    "Shared Read Blocks": 0,
    "Shared Dirtied Blocks": 0,
    "Shared Written Blocks": 0,
    "Local Hit Blocks": 0,
    "Local Read Blocks": 0,
    "Local Dirtied Blocks": 0,
    "Local Written Blocks": 0,
    "Temp Read Blocks": 0,
    "Temp Written Blocks": 0
  },
  "Planning Time": 0.064,
  "Triggers": [
  ],
  "Execution Time": 16.251
}'),
(19, '###### Plan 19: merge LEFT join',
 '{
  "Plan": {
    "Node Type": "Merge Join",
    "Parallel Aware": false,
    "Async Capable": false,
    "Join Type": "Left",
    "Startup Cost": 0.71,
    "Total Cost": 3896.70,
    "Plan Rows": 33843,
    "Plan Width": 4,
    "Actual Startup Time": 0.023,
    "Actual Total Time": 79.653,
    "Actual Rows": 60003,
    "Actual Loops": 1,
    "Output": ["x.b"],
    "Inner Unique": false,
    "Merge Cond": "(x.a = y.a)",
    "Shared Hit Blocks": 35794,
    "Shared Read Blocks": 0,
    "Shared Dirtied Blocks": 0,
    "Shared Written Blocks": 0,
    "Local Hit Blocks": 0,
    "Local Read Blocks": 0,
    "Local Dirtied Blocks": 0,
    "Local Written Blocks": 0,
    "Temp Read Blocks": 0,
    "Temp Written Blocks": 0,
    "Plans": [
      {
        "Node Type": "Index Scan",
        "Parent Relationship": "Outer",
        "Parallel Aware": false,
        "Async Capable": false,
        "Scan Direction": "Forward",
        "Index Name": "i_tt1",
        "Relation Name": "tt1",
        "Schema": "public",
        "Alias": "x",
        "Startup Cost": 0.29,
        "Total Cost": 652.30,
        "Plan Rows": 10001,
        "Plan Width": 8,
        "Actual Startup Time": 0.011,
        "Actual Total Time": 41.908,
        "Actual Rows": 10001,
        "Actual Loops": 1,
        "Output": ["x.a", "x.b", "x.c"],
        "Shared Hit Blocks": 15484,
        "Shared Read Blocks": 0,
        "Shared Dirtied Blocks": 0,
        "Shared Written Blocks": 0,
        "Local Hit Blocks": 0,
        "Local Read Blocks": 0,
        "Local Dirtied Blocks": 0,
        "Local Written Blocks": 0,
        "Temp Read Blocks": 0,
        "Temp Written Blocks": 0
      },
      {
        "Node Type": "Index Only Scan",
        "Parent Relationship": "Inner",
        "Parallel Aware": false,
        "Async Capable": false,
        "Scan Direction": "Forward",
        "Index Name": "i_tt3_a",
        "Relation Name": "tt3",
        "Schema": "public",
        "Alias": "y",
        "Startup Cost": 0.42,
        "Total Cost": 8165.07,
        "Plan Rows": 180003,
        "Plan Width": 4,
        "Actual Startup Time": 0.010,
        "Actual Total Time": 26.692,
        "Actual Rows": 60004,
        "Actual Loops": 1,
        "Output": ["y.a"],
        "Heap Fetches": 60004,
        "Shared Hit Blocks": 20310,
        "Shared Read Blocks": 0,
        "Shared Dirtied Blocks": 0,
        "Shared Written Blocks": 0,
        "Local Hit Blocks": 0,
        "Local Read Blocks": 0,
        "Local Dirtied Blocks": 0,
        "Local Written Blocks": 0,
        "Temp Read Blocks": 0,
        "Temp Written Blocks": 0
      }
    ]
  },
  "Query Identifier": 6407980795008866405,
  "Planning": {
    "Shared Hit Blocks": 41,
    "Shared Read Blocks": 0,
    "Shared Dirtied Blocks": 0,
    "Shared Written Blocks": 0,
    "Local Hit Blocks": 0,
    "Local Read Blocks": 0,
    "Local Dirtied Blocks": 0,
    "Local Written Blocks": 0,
    "Temp Read Blocks": 0,
    "Temp Written Blocks": 0
  },
  "Planning Time": 0.359,
  "Triggers": [
  ],
  "Execution Time": 83.367
}'),
(20, '###### Plan 20: hash FULL join',
 '{
  "Plan": {
    "Node Type": "Hash Join",
    "Parallel Aware": false,
    "Async Capable": false,
    "Join Type": "Full",
    "Startup Cost": 280.02,
    "Total Cost": 680.55,
    "Plan Rows": 10001,
    "Plan Width": 4,
    "Actual Startup Time": 3.709,
    "Actual Total Time": 7.547,
    "Actual Rows": 17001,
    "Actual Loops": 1,
    "Output": ["x.b"],
    "Inner Unique": false,
    "Hash Cond": "(x.a = y.a)",
    "Shared Hit Blocks": 218,
    "Shared Read Blocks": 0,
    "Shared Dirtied Blocks": 0,
    "Shared Written Blocks": 0,
    "Local Hit Blocks": 0,
    "Local Read Blocks": 0,
    "Local Dirtied Blocks": 0,
    "Local Written Blocks": 0,
    "Temp Read Blocks": 0,
    "Temp Written Blocks": 0,
    "Plans": [
      {
        "Node Type": "Seq Scan",
        "Parent Relationship": "Outer",
        "Parallel Aware": false,
        "Async Capable": false,
        "Relation Name": "tt1",
        "Schema": "public",
        "Alias": "x",
        "Startup Cost": 0.00,
        "Total Cost": 263.01,
        "Plan Rows": 10001,
        "Plan Width": 8,
        "Actual Startup Time": 0.118,
        "Actual Total Time": 1.108,
        "Actual Rows": 10001,
        "Actual Loops": 1,
        "Output": ["x.a", "x.b", "x.c"],
        "Shared Hit Blocks": 163,
        "Shared Read Blocks": 0,
        "Shared Dirtied Blocks": 0,
        "Shared Written Blocks": 0,
        "Local Hit Blocks": 0,
        "Local Read Blocks": 0,
        "Local Dirtied Blocks": 0,
        "Local Written Blocks": 0,
        "Temp Read Blocks": 0,
        "Temp Written Blocks": 0
      },
      {
        "Node Type": "Hash",
        "Parent Relationship": "Inner",
        "Parallel Aware": false,
        "Async Capable": false,
        "Startup Cost": 155.01,
        "Total Cost": 155.01,
        "Plan Rows": 10001,
        "Plan Width": 4,
        "Actual Startup Time": 3.579,
        "Actual Total Time": 3.580,
        "Actual Rows": 10001,
        "Actual Loops": 1,
        "Output": ["y.a"],
        "Hash Buckets": 16384,
        "Original Hash Buckets": 16384,
        "Hash Batches": 1,
        "Original Hash Batches": 1,
        "Peak Memory Usage": 480,
        "Shared Hit Blocks": 55,
        "Shared Read Blocks": 0,
        "Shared Dirtied Blocks": 0,
        "Shared Written Blocks": 0,
        "Local Hit Blocks": 0,
        "Local Read Blocks": 0,
        "Local Dirtied Blocks": 0,
        "Local Written Blocks": 0,
        "Temp Read Blocks": 0,
        "Temp Written Blocks": 0,
        "Plans": [
          {
            "Node Type": "Seq Scan",
            "Parent Relationship": "Outer",
            "Parallel Aware": false,
            "Async Capable": false,
            "Relation Name": "tt2",
            "Schema": "public",
            "Alias": "y",
            "Startup Cost": 0.00,
            "Total Cost": 155.01,
            "Plan Rows": 10001,
            "Plan Width": 4,
            "Actual Startup Time": 0.010,
            "Actual Total Time": 1.535,
            "Actual Rows": 10001,
            "Actual Loops": 1,
            "Output": ["y.a"],
            "Shared Hit Blocks": 55,
            "Shared Read Blocks": 0,
            "Shared Dirtied Blocks": 0,
            "Shared Written Blocks": 0,
            "Local Hit Blocks": 0,
            "Local Read Blocks": 0,
            "Local Dirtied Blocks": 0,
            "Local Written Blocks": 0,
            "Temp Read Blocks": 0,
            "Temp Written Blocks": 0
          }
        ]
      }
    ]
  },
  "Query Identifier": 6270931355376407212,
  "Planning": {
    "Shared Hit Blocks": 0,
    "Shared Read Blocks": 0,
    "Shared Dirtied Blocks": 0,
    "Shared Written Blocks": 0,
    "Local Hit Blocks": 0,
    "Local Read Blocks": 0,
    "Local Dirtied Blocks": 0,
    "Local Written Blocks": 0,
    "Temp Read Blocks": 0,
    "Temp Written Blocks": 0
  },
  "Planning Time": 0.099,
  "Triggers": [
  ],
  "Execution Time": 8.382
}'),
(21, '###### Plan 21: hash SEMI join',
 '{
  "Plan": {
    "Node Type": "Hash Join",
    "Parallel Aware": false,
    "Async Capable": false,
    "Join Type": "Semi",
    "Startup Cost": 280.02,
    "Total Cost": 680.55,
    "Plan Rows": 10001,
    "Plan Width": 12,
    "Actual Startup Time": 5.839,
    "Actual Total Time": 5.840,
    "Actual Rows": 0,
    "Actual Loops": 1,
    "Output": ["tt1.a", "tt1.b", "tt1.c"],
    "Inner Unique": false,
    "Hash Cond": "(tt1.a = tt2.b)",
    "Shared Hit Blocks": 218,
    "Shared Read Blocks": 0,
    "Shared Dirtied Blocks": 0,
    "Shared Written Blocks": 0,
    "Local Hit Blocks": 0,
    "Local Read Blocks": 0,
    "Local Dirtied Blocks": 0,
    "Local Written Blocks": 0,
    "Temp Read Blocks": 0,
    "Temp Written Blocks": 0,
    "Plans": [
      {
        "Node Type": "Seq Scan",
        "Parent Relationship": "Outer",
        "Parallel Aware": false,
        "Async Capable": false,
        "Relation Name": "tt1",
        "Schema": "public",
        "Alias": "tt1",
        "Startup Cost": 0.00,
        "Total Cost": 263.01,
        "Plan Rows": 10001,
        "Plan Width": 12,
        "Actual Startup Time": 0.108,
        "Actual Total Time": 1.039,
        "Actual Rows": 10001,
        "Actual Loops": 1,
        "Output": ["tt1.a", "tt1.b", "tt1.c"],
        "Shared Hit Blocks": 163,
        "Shared Read Blocks": 0,
        "Shared Dirtied Blocks": 0,
        "Shared Written Blocks": 0,
        "Local Hit Blocks": 0,
        "Local Read Blocks": 0,
        "Local Dirtied Blocks": 0,
        "Local Written Blocks": 0,
        "Temp Read Blocks": 0,
        "Temp Written Blocks": 0
      },
      {
        "Node Type": "Hash",
        "Parent Relationship": "Inner",
        "Parallel Aware": false,
        "Async Capable": false,
        "Startup Cost": 155.01,
        "Total Cost": 155.01,
        "Plan Rows": 10001,
        "Plan Width": 4,
        "Actual Startup Time": 3.548,
        "Actual Total Time": 3.549,
        "Actual Rows": 10001,
        "Actual Loops": 1,
        "Output": ["tt2.b"],
        "Hash Buckets": 16384,
        "Original Hash Buckets": 16384,
        "Hash Batches": 1,
        "Original Hash Batches": 1,
        "Peak Memory Usage": 480,
        "Shared Hit Blocks": 55,
        "Shared Read Blocks": 0,
        "Shared Dirtied Blocks": 0,
        "Shared Written Blocks": 0,
        "Local Hit Blocks": 0,
        "Local Read Blocks": 0,
        "Local Dirtied Blocks": 0,
        "Local Written Blocks": 0,
        "Temp Read Blocks": 0,
        "Temp Written Blocks": 0,
        "Plans": [
          {
            "Node Type": "Seq Scan",
            "Parent Relationship": "Outer",
            "Parallel Aware": false,
            "Async Capable": false,
            "Relation Name": "tt2",
            "Schema": "public",
            "Alias": "tt2",
            "Startup Cost": 0.00,
            "Total Cost": 155.01,
            "Plan Rows": 10001,
            "Plan Width": 4,
            "Actual Startup Time": 0.008,
            "Actual Total Time": 1.549,
            "Actual Rows": 10001,
            "Actual Loops": 1,
            "Output": ["tt2.b"],
            "Shared Hit Blocks": 55,
            "Shared Read Blocks": 0,
            "Shared Dirtied Blocks": 0,
            "Shared Written Blocks": 0,
            "Local Hit Blocks": 0,
            "Local Read Blocks": 0,
            "Local Dirtied Blocks": 0,
            "Local Written Blocks": 0,
            "Temp Read Blocks": 0,
            "Temp Written Blocks": 0
          }
        ]
      }
    ]
  },
  "Query Identifier": 4261085051587862650,
  "Planning": {
    "Shared Hit Blocks": 8,
    "Shared Read Blocks": 0,
    "Shared Dirtied Blocks": 0,
    "Shared Written Blocks": 0,
    "Local Hit Blocks": 0,
    "Local Read Blocks": 0,
    "Local Dirtied Blocks": 0,
    "Local Written Blocks": 0,
    "Temp Read Blocks": 0,
    "Temp Written Blocks": 0
  },
  "Planning Time": 0.198,
  "Triggers": [
  ],
  "Execution Time": 5.989
}'),
(22, '###### Plan 22: Hash Anti Join',
 '{
  "Plan": {
    "Node Type": "Hash Join",
    "Parallel Aware": false,
    "Async Capable": false,
    "Join Type": "Anti",
    "Startup Cost": 280.02,
    "Total Cost": 580.54,
    "Plan Rows": 1,
    "Plan Width": 12,
    "Actual Startup Time": 3.697,
    "Actual Total Time": 6.706,
    "Actual Rows": 10001,
    "Actual Loops": 1,
    "Output": ["tt1.a", "tt1.b", "tt1.c"],
    "Inner Unique": false,
    "Hash Cond": "(tt1.a = tt2.b)",
    "Shared Hit Blocks": 218,
    "Shared Read Blocks": 0,
    "Shared Dirtied Blocks": 0,
    "Shared Written Blocks": 0,
    "Local Hit Blocks": 0,
    "Local Read Blocks": 0,
    "Local Dirtied Blocks": 0,
    "Local Written Blocks": 0,
    "Temp Read Blocks": 0,
    "Temp Written Blocks": 0,
    "Plans": [
      {
        "Node Type": "Seq Scan",
        "Parent Relationship": "Outer",
        "Parallel Aware": false,
        "Async Capable": false,
        "Relation Name": "tt1",
        "Schema": "public",
        "Alias": "tt1",
        "Startup Cost": 0.00,
        "Total Cost": 263.01,
        "Plan Rows": 10001,
        "Plan Width": 12,
        "Actual Startup Time": 0.091,
        "Actual Total Time": 1.058,
        "Actual Rows": 10001,
        "Actual Loops": 1,
        "Output": ["tt1.a", "tt1.b", "tt1.c"],
        "Shared Hit Blocks": 163,
        "Shared Read Blocks": 0,
        "Shared Dirtied Blocks": 0,
        "Shared Written Blocks": 0,
        "Local Hit Blocks": 0,
        "Local Read Blocks": 0,
        "Local Dirtied Blocks": 0,
        "Local Written Blocks": 0,
        "Temp Read Blocks": 0,
        "Temp Written Blocks": 0
      },
      {
        "Node Type": "Hash",
        "Parent Relationship": "Inner",
        "Parallel Aware": false,
        "Async Capable": false,
        "Startup Cost": 155.01,
        "Total Cost": 155.01,
        "Plan Rows": 10001,
        "Plan Width": 4,
        "Actual Startup Time": 3.599,
        "Actual Total Time": 3.600,
        "Actual Rows": 10001,
        "Actual Loops": 1,
        "Output": ["tt2.b"],
        "Hash Buckets": 16384,
        "Original Hash Buckets": 16384,
        "Hash Batches": 1,
        "Original Hash Batches": 1,
        "Peak Memory Usage": 480,
        "Shared Hit Blocks": 55,
        "Shared Read Blocks": 0,
        "Shared Dirtied Blocks": 0,
        "Shared Written Blocks": 0,
        "Local Hit Blocks": 0,
        "Local Read Blocks": 0,
        "Local Dirtied Blocks": 0,
        "Local Written Blocks": 0,
        "Temp Read Blocks": 0,
        "Temp Written Blocks": 0,
        "Plans": [
          {
            "Node Type": "Seq Scan",
            "Parent Relationship": "Outer",
            "Parallel Aware": false,
            "Async Capable": false,
            "Relation Name": "tt2",
            "Schema": "public",
            "Alias": "tt2",
            "Startup Cost": 0.00,
            "Total Cost": 155.01,
            "Plan Rows": 10001,
            "Plan Width": 4,
            "Actual Startup Time": 0.006,
            "Actual Total Time": 1.664,
            "Actual Rows": 10001,
            "Actual Loops": 1,
            "Output": ["tt2.b"],
            "Shared Hit Blocks": 55,
            "Shared Read Blocks": 0,
            "Shared Dirtied Blocks": 0,
            "Shared Written Blocks": 0,
            "Local Hit Blocks": 0,
            "Local Read Blocks": 0,
            "Local Dirtied Blocks": 0,
            "Local Written Blocks": 0,
            "Temp Read Blocks": 0,
            "Temp Written Blocks": 0
          }
        ]
      }
    ]
  },
  "Query Identifier": -7185004750131138321,
  "Planning": {
    "Shared Hit Blocks": 8,
    "Shared Read Blocks": 0,
    "Shared Dirtied Blocks": 0,
    "Shared Written Blocks": 0,
    "Local Hit Blocks": 0,
    "Local Read Blocks": 0,
    "Local Dirtied Blocks": 0,
    "Local Written Blocks": 0,
    "Temp Read Blocks": 0,
    "Temp Written Blocks": 0
  },
  "Planning Time": 0.141,
  "Triggers": [
  ],
  "Execution Time": 7.273
}'),
(23, '###### Plan 23: WindowAgg',
 '{
  "Plan": {
    "Node Type": "WindowAgg",
    "Parallel Aware": false,
    "Async Capable": false,
    "Startup Cost": 952.47,
    "Total Cost": 1152.49,
    "Plan Rows": 10001,
    "Plan Width": 8,
    "Actual Startup Time": 3.086,
    "Actual Total Time": 10.050,
    "Actual Rows": 10001,
    "Actual Loops": 1,
    "Output": ["first_value(a) OVER (?)", "((a / 10))"],
    "Shared Hit Blocks": 163,
    "Shared Read Blocks": 0,
    "Shared Dirtied Blocks": 0,
    "Shared Written Blocks": 0,
    "Local Hit Blocks": 0,
    "Local Read Blocks": 0,
    "Local Dirtied Blocks": 0,
    "Local Written Blocks": 0,
    "Temp Read Blocks": 0,
    "Temp Written Blocks": 0,
    "Plans": [
      {
        "Node Type": "Sort",
        "Parent Relationship": "Outer",
        "Parallel Aware": false,
        "Async Capable": false,
        "Startup Cost": 952.47,
        "Total Cost": 977.47,
        "Plan Rows": 10001,
        "Plan Width": 8,
        "Actual Startup Time": 3.080,
        "Actual Total Time": 3.676,
        "Actual Rows": 10001,
        "Actual Loops": 1,
        "Output": ["((a / 10))", "a"],
        "Sort Key": ["((tt1.a / 10))"],
        "Sort Method": "quicksort",
        "Sort Space Used": 811,
        "Sort Space Type": "Memory",
        "Shared Hit Blocks": 163,
        "Shared Read Blocks": 0,
        "Shared Dirtied Blocks": 0,
        "Shared Written Blocks": 0,
        "Local Hit Blocks": 0,
        "Local Read Blocks": 0,
        "Local Dirtied Blocks": 0,
        "Local Written Blocks": 0,
        "Temp Read Blocks": 0,
        "Temp Written Blocks": 0,
        "Plans": [
          {
            "Node Type": "Seq Scan",
            "Parent Relationship": "Outer",
            "Parallel Aware": false,
            "Async Capable": false,
            "Relation Name": "tt1",
            "Schema": "public",
            "Alias": "tt1",
            "Startup Cost": 0.00,
            "Total Cost": 288.01,
            "Plan Rows": 10001,
            "Plan Width": 8,
            "Actual Startup Time": 0.095,
            "Actual Total Time": 1.681,
            "Actual Rows": 10001,
            "Actual Loops": 1,
            "Output": ["(a / 10)", "a"],
            "Shared Hit Blocks": 163,
            "Shared Read Blocks": 0,
            "Shared Dirtied Blocks": 0,
            "Shared Written Blocks": 0,
            "Local Hit Blocks": 0,
            "Local Read Blocks": 0,
            "Local Dirtied Blocks": 0,
            "Local Written Blocks": 0,
            "Temp Read Blocks": 0,
            "Temp Written Blocks": 0
          }
        ]
      }
    ]
  },
  "Query Identifier": 690156107702816142,
  "Planning": {
    "Shared Hit Blocks": 0,
    "Shared Read Blocks": 0,
    "Shared Dirtied Blocks": 0,
    "Shared Written Blocks": 0,
    "Local Hit Blocks": 0,
    "Local Read Blocks": 0,
    "Local Dirtied Blocks": 0,
    "Local Written Blocks": 0,
    "Temp Read Blocks": 0,
    "Temp Written Blocks": 0
  },
  "Planning Time": 0.055,
  "Triggers": [
  ],
  "Execution Time": 10.875
}'),
(24, '###### Plan 24: Unique',
 '{
  "Plan": {
    "Node Type": "Unique",
    "Parallel Aware": false,
    "Async Capable": false,
    "Startup Cost": 0.29,
    "Total Cost": 677.30,
    "Plan Rows": 10001,
    "Plan Width": 4,
    "Actual Startup Time": 0.019,
    "Actual Total Time": 43.478,
    "Actual Rows": 10001,
    "Actual Loops": 1,
    "Output": ["a"],
    "Shared Hit Blocks": 15403,
    "Shared Read Blocks": 0,
    "Shared Dirtied Blocks": 0,
    "Shared Written Blocks": 0,
    "Local Hit Blocks": 0,
    "Local Read Blocks": 0,
    "Local Dirtied Blocks": 0,
    "Local Written Blocks": 0,
    "Temp Read Blocks": 0,
    "Temp Written Blocks": 0,
    "Plans": [
      {
        "Node Type": "Index Only Scan",
        "Parent Relationship": "Outer",
        "Parallel Aware": false,
        "Async Capable": false,
        "Scan Direction": "Forward",
        "Index Name": "i_tt1",
        "Relation Name": "tt1",
        "Schema": "public",
        "Alias": "tt1",
        "Startup Cost": 0.29,
        "Total Cost": 652.30,
        "Plan Rows": 10001,
        "Plan Width": 4,
        "Actual Startup Time": 0.018,
        "Actual Total Time": 40.715,
        "Actual Rows": 10001,
        "Actual Loops": 1,
        "Output": ["a"],
        "Heap Fetches": 20208,
        "Shared Hit Blocks": 15403,
        "Shared Read Blocks": 0,
        "Shared Dirtied Blocks": 0,
        "Shared Written Blocks": 0,
        "Local Hit Blocks": 0,
        "Local Read Blocks": 0,
        "Local Dirtied Blocks": 0,
        "Local Written Blocks": 0,
        "Temp Read Blocks": 0,
        "Temp Written Blocks": 0
      }
    ]
  },
  "Query Identifier": -6471828956535608522,
  "Planning": {
    "Shared Hit Blocks": 0,
    "Shared Read Blocks": 0,
    "Shared Dirtied Blocks": 0,
    "Shared Written Blocks": 0,
    "Local Hit Blocks": 0,
    "Local Read Blocks": 0,
    "Local Dirtied Blocks": 0,
    "Local Written Blocks": 0,
    "Temp Read Blocks": 0,
    "Temp Written Blocks": 0
  },
  "Planning Time": 0.048,
  "Triggers": [
  ],
  "Execution Time": 44.166
}'),
(25, '###### Plan 25: PlainAggregate',
 '{
  "Plan": {
    "Node Type": "Aggregate",
    "Strategy": "Plain",
    "Partial Mode": "Simple",
    "Parallel Aware": false,
    "Async Capable": false,
    "Startup Cost": 288.01,
    "Total Cost": 288.02,
    "Plan Rows": 1,
    "Plan Width": 8,
    "Actual Startup Time": 1.891,
    "Actual Total Time": 1.891,
    "Actual Rows": 1,
    "Actual Loops": 1,
    "Output": ["sum(a)"],
    "Shared Hit Blocks": 163,
    "Shared Read Blocks": 0,
    "Shared Dirtied Blocks": 0,
    "Shared Written Blocks": 0,
    "Local Hit Blocks": 0,
    "Local Read Blocks": 0,
    "Local Dirtied Blocks": 0,
    "Local Written Blocks": 0,
    "Temp Read Blocks": 0,
    "Temp Written Blocks": 0,
    "Plans": [
      {
        "Node Type": "Seq Scan",
        "Parent Relationship": "Outer",
        "Parallel Aware": false,
        "Async Capable": false,
        "Relation Name": "tt1",
        "Schema": "public",
        "Alias": "tt1",
        "Startup Cost": 0.00,
        "Total Cost": 263.01,
        "Plan Rows": 10001,
        "Plan Width": 4,
        "Actual Startup Time": 0.102,
        "Actual Total Time": 1.007,
        "Actual Rows": 10001,
        "Actual Loops": 1,
        "Output": ["a", "b", "c"],
        "Shared Hit Blocks": 163,
        "Shared Read Blocks": 0,
        "Shared Dirtied Blocks": 0,
        "Shared Written Blocks": 0,
        "Local Hit Blocks": 0,
        "Local Read Blocks": 0,
        "Local Dirtied Blocks": 0,
        "Local Written Blocks": 0,
        "Temp Read Blocks": 0,
        "Temp Written Blocks": 0
      }
    ]
  },
  "Query Identifier": -1408771519844137372,
  "Planning": {
    "Shared Hit Blocks": 3,
    "Shared Read Blocks": 0,
    "Shared Dirtied Blocks": 0,
    "Shared Written Blocks": 0,
    "Local Hit Blocks": 0,
    "Local Read Blocks": 0,
    "Local Dirtied Blocks": 0,
    "Local Written Blocks": 0,
    "Temp Read Blocks": 0,
    "Temp Written Blocks": 0
  },
  "Planning Time": 0.089,
  "Triggers": [
  ],
  "Execution Time": 1.977
}'),
(26, '###### Plan 26: BitmapIndexScan/BitmapHeapScan, BitmapOr, lossy',
 E'{
  "Plan": {
    "Node Type": "Bitmap Heap Scan",
    "Parallel Aware": false,
    "Async Capable": false,
    "Relation Name": "tt3",
    "Schema": "public",
    "Alias": "tt3",
    "Startup Cost": 3947.41,
    "Total Cost": 7170.40,
    "Plan Rows": 179999,
    "Plan Width": 12,
    "Actual Startup Time": 13.974,
    "Actual Total Time": 39.032,
    "Actual Rows": 180000,
    "Actual Loops": 1,
    "Output": ["a", "b", "c"],
    "Recheck Cond": "(tt3.b > \'-99998\'::integer)",
    "Rows Removed by Index Recheck": 0,
    "Exact Heap Blocks": 973,
    "Lossy Heap Blocks": 0,
    "Shared Hit Blocks": 1609,
    "Shared Read Blocks": 0,
    "Shared Dirtied Blocks": 0,
    "Shared Written Blocks": 0,
    "Local Hit Blocks": 0,
    "Local Read Blocks": 0,
    "Local Dirtied Blocks": 0,
    "Local Written Blocks": 0,
    "Temp Read Blocks": 0,
    "Temp Written Blocks": 0,
    "Plans": [
      {
        "Node Type": "Bitmap Index Scan",
        "Parent Relationship": "Outer",
        "Parallel Aware": false,
        "Async Capable": false,
        "Index Name": "i_tt3_b",
        "Startup Cost": 0.00,
        "Total Cost": 3902.41,
        "Plan Rows": 179999,
        "Plan Width": 0,
        "Actual Startup Time": 13.806,
        "Actual Total Time": 13.806,
        "Actual Rows": 180000,
        "Actual Loops": 1,
        "Index Cond": "(tt3.b > \'-99998\'::integer)",
        "Shared Hit Blocks": 636,
        "Shared Read Blocks": 0,
        "Shared Dirtied Blocks": 0,
        "Shared Written Blocks": 0,
        "Local Hit Blocks": 0,
        "Local Read Blocks": 0,
        "Local Dirtied Blocks": 0,
        "Local Written Blocks": 0,
        "Temp Read Blocks": 0,
        "Temp Written Blocks": 0
      }
    ]
  },
  "Query Identifier": 3655576001285864679,
  "Planning": {
    "Shared Hit Blocks": 10,
    "Shared Read Blocks": 0,
    "Shared Dirtied Blocks": 0,
    "Shared Written Blocks": 0,
    "Local Hit Blocks": 0,
    "Local Read Blocks": 0,
    "Local Dirtied Blocks": 0,
    "Local Written Blocks": 0,
    "Temp Read Blocks": 0,
    "Temp Written Blocks": 0
  },
  "Planning Time": 0.086,
  "Triggers": [
  ],
  "Execution Time": 45.361
}'),
(27, '###### Plan 27: Join Filter',
 '{
  "Plan": {
    "Node Type": "Limit",
    "Parallel Aware": false,
    "Async Capable": false,
    "Startup Cost": 0.00,
    "Total Cost": 21.52,
    "Plan Rows": 100,
    "Plan Width": 12,
    "Actual Startup Time": 4.754,
    "Actual Total Time": 4.838,
    "Actual Rows": 100,
    "Actual Loops": 1,
    "Output": ["tt2.a", "tt2.b", "tt2.c"],
    "Shared Hit Blocks": 40,
    "Shared Read Blocks": 0,
    "Shared Dirtied Blocks": 0,
    "Shared Written Blocks": 0,
    "Local Hit Blocks": 0,
    "Local Read Blocks": 0,
    "Local Dirtied Blocks": 0,
    "Local Written Blocks": 0,
    "Temp Read Blocks": 0,
    "Temp Written Blocks": 12,
    "Plans": [
      {
        "Node Type": "Nested Loop",
        "Parent Relationship": "Outer",
        "Parallel Aware": false,
        "Async Capable": false,
        "Join Type": "Inner",
        "Startup Cost": 0.00,
        "Total Cost": 43048282.11,
        "Plan Rows": 200023334,
        "Plan Width": 12,
        "Actual Startup Time": 4.753,
        "Actual Total Time": 4.828,
        "Actual Rows": 100,
        "Actual Loops": 1,
        "Output": ["tt2.a", "tt2.b", "tt2.c"],
        "Inner Unique": false,
        "Join Filter": "((tt2.a < tt3.a) AND ((tt3.a + tt2.a) < 100000))",
        "Rows Removed by Join Filter": 7001,
        "Shared Hit Blocks": 40,
        "Shared Read Blocks": 0,
        "Shared Dirtied Blocks": 0,
        "Shared Written Blocks": 0,
        "Local Hit Blocks": 0,
        "Local Read Blocks": 0,
        "Local Dirtied Blocks": 0,
        "Local Written Blocks": 0,
        "Temp Read Blocks": 0,
        "Temp Written Blocks": 12,
        "Plans": [
          {
            "Node Type": "Seq Scan",
            "Parent Relationship": "Outer",
            "Parallel Aware": false,
            "Async Capable": false,
            "Relation Name": "tt2",
            "Schema": "public",
            "Alias": "tt2",
            "Startup Cost": 0.00,
            "Total Cost": 155.01,
            "Plan Rows": 10001,
            "Plan Width": 12,
            "Actual Startup Time": 0.008,
            "Actual Total Time": 0.008,
            "Actual Rows": 1,
            "Actual Loops": 1,
            "Output": ["tt2.a", "tt2.b", "tt2.c"],
            "Shared Hit Blocks": 1,
            "Shared Read Blocks": 0,
            "Shared Dirtied Blocks": 0,
            "Shared Written Blocks": 0,
            "Local Hit Blocks": 0,
            "Local Read Blocks": 0,
            "Local Dirtied Blocks": 0,
            "Local Written Blocks": 0,
            "Temp Read Blocks": 0,
            "Temp Written Blocks": 0
          },
          {
            "Node Type": "Materialize",
            "Parent Relationship": "Inner",
            "Parallel Aware": false,
            "Async Capable": false,
            "Startup Cost": 0.00,
            "Total Cost": 4377.05,
            "Plan Rows": 180003,
            "Plan Width": 4,
            "Actual Startup Time": 0.008,
            "Actual Total Time": 3.931,
            "Actual Rows": 7101,
            "Actual Loops": 1,
            "Output": ["tt3.a"],
            "Shared Hit Blocks": 39,
            "Shared Read Blocks": 0,
            "Shared Dirtied Blocks": 0,
            "Shared Written Blocks": 0,
            "Local Hit Blocks": 0,
            "Local Read Blocks": 0,
            "Local Dirtied Blocks": 0,
            "Local Written Blocks": 0,
            "Temp Read Blocks": 0,
            "Temp Written Blocks": 12,
            "Plans": [
              {
                "Node Type": "Seq Scan",
                "Parent Relationship": "Outer",
                "Parallel Aware": false,
                "Async Capable": false,
                "Relation Name": "tt3",
                "Schema": "public",
                "Alias": "tt3",
                "Startup Cost": 0.00,
                "Total Cost": 2773.03,
                "Plan Rows": 180003,
                "Plan Width": 4,
                "Actual Startup Time": 0.006,
                "Actual Total Time": 1.175,
                "Actual Rows": 7101,
                "Actual Loops": 1,
                "Output": ["tt3.a"],
                "Shared Hit Blocks": 39,
                "Shared Read Blocks": 0,
                "Shared Dirtied Blocks": 0,
                "Shared Written Blocks": 0,
                "Local Hit Blocks": 0,
                "Local Read Blocks": 0,
                "Local Dirtied Blocks": 0,
                "Local Written Blocks": 0,
                "Temp Read Blocks": 0,
                "Temp Written Blocks": 0
              }
            ]
          }
        ]
      }
    ]
  },
  "Query Identifier": -6470911155177616069,
  "Planning": {
    "Shared Hit Blocks": 3,
    "Shared Read Blocks": 0,
    "Shared Dirtied Blocks": 0,
    "Shared Written Blocks": 0,
    "Local Hit Blocks": 0,
    "Local Read Blocks": 0,
    "Local Dirtied Blocks": 0,
    "Local Written Blocks": 0,
    "Temp Read Blocks": 0,
    "Temp Written Blocks": 0
  },
  "Planning Time": 0.151,
  "Triggers": [
  ],
  "Execution Time": 5.042
}'),
(28, '###### Plan 28: TidScan',
 E'{
  "Plan": {
    "Node Type": "Tid Scan",
    "Parallel Aware": false,
    "Async Capable": false,
    "Relation Name": "tt3",
    "Schema": "public",
    "Alias": "tt3",
    "Startup Cost": 0.00,
    "Total Cost": 4.01,
    "Plan Rows": 1,
    "Plan Width": 12,
    "Actual Startup Time": 0.004,
    "Actual Total Time": 0.004,
    "Actual Rows": 1,
    "Actual Loops": 1,
    "Output": ["a", "b", "c"],
    "TID Cond": "(tt3.ctid = \'(0,28)\'::tid)",
    "Shared Hit Blocks": 1,
    "Shared Read Blocks": 0,
    "Shared Dirtied Blocks": 0,
    "Shared Written Blocks": 0,
    "Local Hit Blocks": 0,
    "Local Read Blocks": 0,
    "Local Dirtied Blocks": 0,
    "Local Written Blocks": 0,
    "Temp Read Blocks": 0,
    "Temp Written Blocks": 0
  },
  "Query Identifier": -6453669687351238517,
  "Planning": {
    "Shared Hit Blocks": 7,
    "Shared Read Blocks": 0,
    "Shared Dirtied Blocks": 0,
    "Shared Written Blocks": 0,
    "Local Hit Blocks": 0,
    "Local Read Blocks": 0,
    "Local Dirtied Blocks": 0,
    "Local Written Blocks": 0,
    "Temp Read Blocks": 0,
    "Temp Written Blocks": 0
  },
  "Planning Time": 0.092,
  "Triggers": [
  ],
  "Execution Time": 0.061
}'),
(29, '###### Plan 29: LockRows',
 '{
  "Plan": {
    "Node Type": "LockRows",
    "Parallel Aware": false,
    "Async Capable": false,
    "Startup Cost": 0.00,
    "Total Cost": 313.51,
    "Plan Rows": 50,
    "Plan Width": 10,
    "Actual Startup Time": 0.133,
    "Actual Total Time": 2.182,
    "Actual Rows": 1001,
    "Actual Loops": 1,
    "Output": ["a", "ctid"],
    "Shared Hit Blocks": 1164,
    "Shared Read Blocks": 0,
    "Shared Dirtied Blocks": 0,
    "Shared Written Blocks": 0,
    "Local Hit Blocks": 0,
    "Local Read Blocks": 0,
    "Local Dirtied Blocks": 0,
    "Local Written Blocks": 0,
    "Temp Read Blocks": 0,
    "Temp Written Blocks": 0,
    "Plans": [
      {
        "Node Type": "Seq Scan",
        "Parent Relationship": "Outer",
        "Parallel Aware": false,
        "Async Capable": false,
        "Relation Name": "tt1",
        "Schema": "public",
        "Alias": "tt1",
        "Startup Cost": 0.00,
        "Total Cost": 313.01,
        "Plan Rows": 50,
        "Plan Width": 10,
        "Actual Startup Time": 0.124,
        "Actual Total Time": 1.475,
        "Actual Rows": 1001,
        "Actual Loops": 1,
        "Output": ["a", "ctid"],
        "Filter": "((tt1.a % 10) = 0)",
        "Rows Removed by Filter": 9000,
        "Shared Hit Blocks": 163,
        "Shared Read Blocks": 0,
        "Shared Dirtied Blocks": 0,
        "Shared Written Blocks": 0,
        "Local Hit Blocks": 0,
        "Local Read Blocks": 0,
        "Local Dirtied Blocks": 0,
        "Local Written Blocks": 0,
        "Temp Read Blocks": 0,
        "Temp Written Blocks": 0
      }
    ]
  },
  "Query Identifier": 4944542912050316181,
  "Planning": {
    "Shared Hit Blocks": 0,
    "Shared Read Blocks": 0,
    "Shared Dirtied Blocks": 0,
    "Shared Written Blocks": 0,
    "Local Hit Blocks": 0,
    "Local Read Blocks": 0,
    "Local Dirtied Blocks": 0,
    "Local Written Blocks": 0,
    "Temp Read Blocks": 0,
    "Temp Written Blocks": 0
  },
  "Planning Time": 0.032,
  "Triggers": [
  ],
  "Execution Time": 2.320
}'),
(30, '###### Plan 30: Materialize',
 '{
  "Plan": {
    "Node Type": "Seq Scan",
    "Parallel Aware": false,
    "Async Capable": false,
    "Relation Name": "tt1",
    "Schema": "public",
    "Alias": "tt1",
    "Startup Cost": 0.00,
    "Total Cost": 1150490.52,
    "Plan Rows": 5000,
    "Plan Width": 12,
    "Actual Startup Time": 60.414,
    "Actual Total Time": 60.415,
    "Actual Rows": 0,
    "Actual Loops": 1,
    "Output": ["tt1.a", "tt1.b", "tt1.c"],
    "Filter": "(SubPlan 1)",
    "Rows Removed by Filter": 10001,
    "Shared Hit Blocks": 164,
    "Shared Read Blocks": 0,
    "Shared Dirtied Blocks": 0,
    "Shared Written Blocks": 0,
    "Local Hit Blocks": 0,
    "Local Read Blocks": 0,
    "Local Dirtied Blocks": 0,
    "Local Written Blocks": 0,
    "Temp Read Blocks": 0,
    "Temp Written Blocks": 0,
    "Plans": [
      {
        "Node Type": "Materialize",
        "Parent Relationship": "SubPlan",
        "Subplan Name": "SubPlan 1",
        "Parallel Aware": false,
        "Async Capable": false,
        "Startup Cost": 0.00,
        "Total Cost": 205.01,
        "Plan Rows": 10001,
        "Plan Width": 4,
        "Actual Startup Time": 0.000,
        "Actual Total Time": 0.000,
        "Actual Rows": 1,
        "Actual Loops": 10001,
        "Output": ["tt2.b"],
        "Shared Hit Blocks": 1,
        "Shared Read Blocks": 0,
        "Shared Dirtied Blocks": 0,
        "Shared Written Blocks": 0,
        "Local Hit Blocks": 0,
        "Local Read Blocks": 0,
        "Local Dirtied Blocks": 0,
        "Local Written Blocks": 0,
        "Temp Read Blocks": 0,
        "Temp Written Blocks": 0,
        "Plans": [
          {
            "Node Type": "Seq Scan",
            "Parent Relationship": "Outer",
            "Parallel Aware": false,
            "Async Capable": false,
            "Relation Name": "tt2",
            "Schema": "public",
            "Alias": "tt2",
            "Startup Cost": 0.00,
            "Total Cost": 155.01,
            "Plan Rows": 10001,
            "Plan Width": 4,
            "Actual Startup Time": 0.029,
            "Actual Total Time": 0.029,
            "Actual Rows": 1,
            "Actual Loops": 1,
            "Output": ["tt2.b"],
            "Shared Hit Blocks": 1,
            "Shared Read Blocks": 0,
            "Shared Dirtied Blocks": 0,
            "Shared Written Blocks": 0,
            "Local Hit Blocks": 0,
            "Local Read Blocks": 0,
            "Local Dirtied Blocks": 0,
            "Local Written Blocks": 0,
            "Temp Read Blocks": 0,
            "Temp Written Blocks": 0
          }
        ]
      }
    ]
  },
  "Query Identifier": 3250896580163603382,
  "Planning": {
    "Shared Hit Blocks": 0,
    "Shared Read Blocks": 0,
    "Shared Dirtied Blocks": 0,
    "Shared Written Blocks": 0,
    "Local Hit Blocks": 0,
    "Local Read Blocks": 0,
    "Local Dirtied Blocks": 0,
    "Local Written Blocks": 0,
    "Temp Read Blocks": 0,
    "Temp Written Blocks": 0
  },
  "Planning Time": 0.049,
  "Triggers": [
  ],
  "JIT": {
    "Functions": 6,
    "Options": {
      "Inlining": true,
      "Optimization": true,
      "Expressions": true,
      "Deforming": true
    },
    "Timing": {
      "Generation": 0.157,
      "Inlining": 41.771,
      "Optimization": 9.342,
      "Emission": 6.932,
      "Total": 58.202
    }
  },
  "Execution Time": 68.807
}'),
(31, '###### Plan 31: Update on partitioned tables',
 '{
  "Plan": {
    "Node Type": "ModifyTable",
    "Operation": "Update",
    "Parallel Aware": false,
    "Async Capable": false,
    "Relation Name": "p",
    "Schema": "public",
    "Alias": "p",
    "Startup Cost": 0.00,
    "Total Cost": 6691.16,
    "Plan Rows": 0,
    "Plan Width": 0,
    "Actual Startup Time": 3001.086,
    "Actual Total Time": 3001.090,
    "Actual Rows": 0,
    "Actual Loops": 1,
    "Target Tables": [
      {
        "Relation Name": "p",
        "Schema": "public",
        "Alias": "p_1"
      },
      {
        "Relation Name": "tt1",
        "Schema": "public",
        "Alias": "p_2"
      },
      {
        "Relation Name": "tt2",
        "Schema": "public",
        "Alias": "p_3"
      },
      {
        "Relation Name": "tt3",
        "Schema": "public",
        "Alias": "p_4"
      }
    ],
    "Shared Hit Blocks": 1736974,
    "Shared Read Blocks": 0,
    "Shared Dirtied Blocks": 1553,
    "Shared Written Blocks": 1553,
    "Local Hit Blocks": 0,
    "Local Read Blocks": 0,
    "Local Dirtied Blocks": 0,
    "Local Written Blocks": 0,
    "Temp Read Blocks": 0,
    "Temp Written Blocks": 0,
    "Plans": [
      {
        "Node Type": "Result",
        "Parent Relationship": "Outer",
        "Parallel Aware": false,
        "Async Capable": false,
        "Startup Cost": 0.00,
        "Total Cost": 6691.16,
        "Plan Rows": 200006,
        "Plan Width": 14,
        "Actual Startup Time": 0.136,
        "Actual Total Time": 122.193,
        "Actual Rows": 200005,
        "Actual Loops": 1,
        "Output": ["(p.b + 1)", "p.tableoid", "p.ctid"],
        "Shared Hit Blocks": 1191,
        "Shared Read Blocks": 0,
        "Shared Dirtied Blocks": 0,
        "Shared Written Blocks": 0,
        "Local Hit Blocks": 0,
        "Local Read Blocks": 0,
        "Local Dirtied Blocks": 0,
        "Local Written Blocks": 0,
        "Temp Read Blocks": 0,
        "Temp Written Blocks": 0,
        "Plans": [
          {
            "Node Type": "Append",
            "Parent Relationship": "Outer",
            "Parallel Aware": false,
            "Async Capable": false,
            "Startup Cost": 0.00,
            "Total Cost": 4191.08,
            "Plan Rows": 200006,
            "Plan Width": 14,
            "Actual Startup Time": 0.134,
            "Actual Total Time": 73.335,
            "Actual Rows": 200005,
            "Actual Loops": 1,
            "Shared Hit Blocks": 1191,
            "Shared Read Blocks": 0,
            "Shared Dirtied Blocks": 0,
            "Shared Written Blocks": 0,
            "Local Hit Blocks": 0,
            "Local Read Blocks": 0,
            "Local Dirtied Blocks": 0,
            "Local Written Blocks": 0,
            "Temp Read Blocks": 0,
            "Temp Written Blocks": 0,
            "Subplans Removed": 0,
            "Plans": [
              {
                "Node Type": "Seq Scan",
                "Parent Relationship": "Member",
                "Parallel Aware": false,
                "Async Capable": false,
                "Relation Name": "p",
                "Schema": "public",
                "Alias": "p_1",
                "Startup Cost": 0.00,
                "Total Cost": 0.00,
                "Plan Rows": 1,
                "Plan Width": 14,
                "Actual Startup Time": 0.001,
                "Actual Total Time": 0.002,
                "Actual Rows": 0,
                "Actual Loops": 1,
                "Output": ["p_1.b", "p_1.tableoid", "p_1.ctid"],
                "Shared Hit Blocks": 0,
                "Shared Read Blocks": 0,
                "Shared Dirtied Blocks": 0,
                "Shared Written Blocks": 0,
                "Local Hit Blocks": 0,
                "Local Read Blocks": 0,
                "Local Dirtied Blocks": 0,
                "Local Written Blocks": 0,
                "Temp Read Blocks": 0,
                "Temp Written Blocks": 0
              },
              {
                "Node Type": "Seq Scan",
                "Parent Relationship": "Member",
                "Parallel Aware": false,
                "Async Capable": false,
                "Relation Name": "tt1",
                "Schema": "public",
                "Alias": "p_2",
                "Startup Cost": 0.00,
                "Total Cost": 263.01,
                "Plan Rows": 10001,
                "Plan Width": 14,
                "Actual Startup Time": 0.132,
                "Actual Total Time": 3.167,
                "Actual Rows": 10001,
                "Actual Loops": 1,
                "Output": ["p_2.b", "p_2.tableoid", "p_2.ctid"],
                "Shared Hit Blocks": 163,
                "Shared Read Blocks": 0,
                "Shared Dirtied Blocks": 0,
                "Shared Written Blocks": 0,
                "Local Hit Blocks": 0,
                "Local Read Blocks": 0,
                "Local Dirtied Blocks": 0,
                "Local Written Blocks": 0,
                "Temp Read Blocks": 0,
                "Temp Written Blocks": 0
              },
              {
                "Node Type": "Seq Scan",
                "Parent Relationship": "Member",
                "Parallel Aware": false,
                "Async Capable": false,
                "Relation Name": "tt2",
                "Schema": "public",
                "Alias": "p_3",
                "Startup Cost": 0.00,
                "Total Cost": 155.01,
                "Plan Rows": 10001,
                "Plan Width": 14,
                "Actual Startup Time": 0.011,
                "Actual Total Time": 2.816,
                "Actual Rows": 10001,
                "Actual Loops": 1,
                "Output": ["p_3.b", "p_3.tableoid", "p_3.ctid"],
                "Shared Hit Blocks": 55,
                "Shared Read Blocks": 0,
                "Shared Dirtied Blocks": 0,
                "Shared Written Blocks": 0,
                "Local Hit Blocks": 0,
                "Local Read Blocks": 0,
                "Local Dirtied Blocks": 0,
                "Local Written Blocks": 0,
                "Temp Read Blocks": 0,
                "Temp Written Blocks": 0
              },
              {
                "Node Type": "Seq Scan",
                "Parent Relationship": "Member",
                "Parallel Aware": false,
                "Async Capable": false,
                "Relation Name": "tt3",
                "Schema": "public",
                "Alias": "p_4",
                "Startup Cost": 0.00,
                "Total Cost": 2773.03,
                "Plan Rows": 180003,
                "Plan Width": 14,
                "Actual Startup Time": 0.011,
                "Actual Total Time": 49.308,
                "Actual Rows": 180003,
                "Actual Loops": 1,
                "Output": ["p_4.b", "p_4.tableoid", "p_4.ctid"],
                "Shared Hit Blocks": 973,
                "Shared Read Blocks": 0,
                "Shared Dirtied Blocks": 0,
                "Shared Written Blocks": 0,
                "Local Hit Blocks": 0,
                "Local Read Blocks": 0,
                "Local Dirtied Blocks": 0,
                "Local Written Blocks": 0,
                "Temp Read Blocks": 0,
                "Temp Written Blocks": 0
              }
            ]
          }
        ]
      }
    ]
  },
  "Query Identifier": 4569748805178305126,
  "Planning": {
    "Shared Hit Blocks": 6,
    "Shared Read Blocks": 0,
    "Shared Dirtied Blocks": 0,
    "Shared Written Blocks": 0,
    "Local Hit Blocks": 0,
    "Local Read Blocks": 0,
    "Local Dirtied Blocks": 0,
    "Local Written Blocks": 0,
    "Temp Read Blocks": 0,
    "Temp Written Blocks": 0
  },
  "Planning Time": 0.137,
  "Triggers": [
    {
      "Trigger Name": "tt1_trig_1",
      "Relation": "tt1",
      "Time": 24.035,
      "Calls": 10001
    },
    {
      "Trigger Name": "tt1_trig_2",
      "Relation": "tt1",
      "Time": 20.719,
      "Calls": 10001
    }
  ],
  "Execution Time": 3001.370
}'),
(32, '###### Plan 32: Delete on partitioned tables',
 '{
  "Plan": {
    "Node Type": "ModifyTable",
    "Operation": "Delete",
    "Parallel Aware": false,
    "Async Capable": false,
    "Relation Name": "p",
    "Schema": "public",
    "Alias": "p",
    "Startup Cost": 0.00,
    "Total Cost": 32.81,
    "Plan Rows": 0,
    "Plan Width": 0,
    "Actual Startup Time": 0.231,
    "Actual Total Time": 0.232,
    "Actual Rows": 0,
    "Actual Loops": 1,
    "Target Tables": [
      {
        "Relation Name": "p",
        "Schema": "public",
        "Alias": "p_1"
      },
      {
        "Relation Name": "tt1",
        "Schema": "public",
        "Alias": "p_2"
      },
      {
        "Relation Name": "tt2",
        "Schema": "public",
        "Alias": "p_3"
      },
      {
        "Relation Name": "tt3",
        "Schema": "public",
        "Alias": "p_4"
      }
    ],
    "Shared Hit Blocks": 18,
    "Shared Read Blocks": 0,
    "Shared Dirtied Blocks": 0,
    "Shared Written Blocks": 0,
    "Local Hit Blocks": 0,
    "Local Read Blocks": 0,
    "Local Dirtied Blocks": 0,
    "Local Written Blocks": 0,
    "Temp Read Blocks": 0,
    "Temp Written Blocks": 0,
    "Plans": [
      {
        "Node Type": "Append",
        "Parent Relationship": "Outer",
        "Parallel Aware": false,
        "Async Capable": false,
        "Startup Cost": 0.00,
        "Total Cost": 32.81,
        "Plan Rows": 6,
        "Plan Width": 10,
        "Actual Startup Time": 0.114,
        "Actual Total Time": 0.217,
        "Actual Rows": 3,
        "Actual Loops": 1,
        "Shared Hit Blocks": 15,
        "Shared Read Blocks": 0,
        "Shared Dirtied Blocks": 0,
        "Shared Written Blocks": 0,
        "Local Hit Blocks": 0,
        "Local Read Blocks": 0,
        "Local Dirtied Blocks": 0,
        "Local Written Blocks": 0,
        "Temp Read Blocks": 0,
        "Temp Written Blocks": 0,
        "Subplans Removed": 0,
        "Plans": [
          {
            "Node Type": "Seq Scan",
            "Parent Relationship": "Member",
            "Parallel Aware": false,
            "Async Capable": false,
            "Relation Name": "p",
            "Schema": "public",
            "Alias": "p_1",
            "Startup Cost": 0.00,
            "Total Cost": 0.00,
            "Plan Rows": 1,
            "Plan Width": 10,
            "Actual Startup Time": 0.006,
            "Actual Total Time": 0.006,
            "Actual Rows": 0,
            "Actual Loops": 1,
            "Output": ["p_1.tableoid", "p_1.ctid"],
            "Filter": "(p_1.a = 100)",
            "Rows Removed by Filter": 0,
            "Shared Hit Blocks": 0,
            "Shared Read Blocks": 0,
            "Shared Dirtied Blocks": 0,
            "Shared Written Blocks": 0,
            "Local Hit Blocks": 0,
            "Local Read Blocks": 0,
            "Local Dirtied Blocks": 0,
            "Local Written Blocks": 0,
            "Temp Read Blocks": 0,
            "Temp Written Blocks": 0
          },
          {
            "Node Type": "Index Scan",
            "Parent Relationship": "Member",
            "Parallel Aware": false,
            "Async Capable": false,
            "Scan Direction": "Forward",
            "Index Name": "i_tt1",
            "Relation Name": "tt1",
            "Schema": "public",
            "Alias": "p_2",
            "Startup Cost": 0.29,
            "Total Cost": 8.30,
            "Plan Rows": 1,
            "Plan Width": 10,
            "Actual Startup Time": 0.107,
            "Actual Total Time": 0.109,
            "Actual Rows": 1,
            "Actual Loops": 1,
            "Output": ["p_2.tableoid", "p_2.ctid"],
            "Index Cond": "(p_2.a = 100)",
            "Rows Removed by Index Recheck": 0,
            "Shared Hit Blocks": 5,
            "Shared Read Blocks": 0,
            "Shared Dirtied Blocks": 0,
            "Shared Written Blocks": 0,
            "Local Hit Blocks": 0,
            "Local Read Blocks": 0,
            "Local Dirtied Blocks": 0,
            "Local Written Blocks": 0,
            "Temp Read Blocks": 0,
            "Temp Written Blocks": 0
          },
          {
            "Node Type": "Index Scan",
            "Parent Relationship": "Member",
            "Parallel Aware": false,
            "Async Capable": false,
            "Scan Direction": "Forward",
            "Index Name": "i_tt2",
            "Relation Name": "tt2",
            "Schema": "public",
            "Alias": "p_3",
            "Startup Cost": 0.29,
            "Total Cost": 8.30,
            "Plan Rows": 1,
            "Plan Width": 10,
            "Actual Startup Time": 0.011,
            "Actual Total Time": 0.011,
            "Actual Rows": 0,
            "Actual Loops": 1,
            "Output": ["p_3.tableoid", "p_3.ctid"],
            "Index Cond": "(p_3.a = 100)",
            "Rows Removed by Index Recheck": 0,
            "Shared Hit Blocks": 2,
            "Shared Read Blocks": 0,
            "Shared Dirtied Blocks": 0,
            "Shared Written Blocks": 0,
            "Local Hit Blocks": 0,
            "Local Read Blocks": 0,
            "Local Dirtied Blocks": 0,
            "Local Written Blocks": 0,
            "Temp Read Blocks": 0,
            "Temp Written Blocks": 0
          },
          {
            "Node Type": "Index Scan",
            "Parent Relationship": "Member",
            "Parallel Aware": false,
            "Async Capable": false,
            "Scan Direction": "Forward",
            "Index Name": "i_tt3_a",
            "Relation Name": "tt3",
            "Schema": "public",
            "Alias": "p_4",
            "Startup Cost": 0.42,
            "Total Cost": 16.17,
            "Plan Rows": 3,
            "Plan Width": 10,
            "Actual Startup Time": 0.082,
            "Actual Total Time": 0.089,
            "Actual Rows": 2,
            "Actual Loops": 1,
            "Output": ["p_4.tableoid", "p_4.ctid"],
            "Index Cond": "(p_4.a = 100)",
            "Rows Removed by Index Recheck": 0,
            "Shared Hit Blocks": 8,
            "Shared Read Blocks": 0,
            "Shared Dirtied Blocks": 0,
            "Shared Written Blocks": 0,
            "Local Hit Blocks": 0,
            "Local Read Blocks": 0,
            "Local Dirtied Blocks": 0,
            "Local Written Blocks": 0,
            "Temp Read Blocks": 0,
            "Temp Written Blocks": 0
          }
        ]
      }
    ]
  },
  "Query Identifier": 4127310819418609931,
  "Planning": {
    "Shared Hit Blocks": 4,
    "Shared Read Blocks": 0,
    "Shared Dirtied Blocks": 0,
    "Shared Written Blocks": 0,
    "Local Hit Blocks": 0,
    "Local Read Blocks": 0,
    "Local Dirtied Blocks": 0,
    "Local Written Blocks": 0,
    "Temp Read Blocks": 0,
    "Temp Written Blocks": 0
  },
  "Planning Time": 0.232,
  "Triggers": [
  ],
  "Execution Time": 0.468
}'),
(33, '###### Plan 33: ON CONFLICT',
 '{
  "Plan": {
    "Node Type": "ModifyTable",
    "Operation": "Insert",
    "Parallel Aware": false,
    "Async Capable": false,
    "Relation Name": "ct1",
    "Schema": "public",
    "Alias": "ct1",
    "Startup Cost": 0.00,
    "Total Cost": 0.01,
    "Plan Rows": 0,
    "Plan Width": 0,
    "Actual Startup Time": 0.054,
    "Actual Total Time": 0.054,
    "Actual Rows": 0,
    "Actual Loops": 1,
    "Conflict Resolution": "UPDATE",
    "Conflict Arbiter Indexes": ["ct1_a_key"],
    "Tuples Inserted": 0,
    "Conflicting Tuples": 1,
    "Shared Hit Blocks": 4,
    "Shared Read Blocks": 1,
    "Shared Dirtied Blocks": 0,
    "Shared Written Blocks": 0,
    "Local Hit Blocks": 0,
    "Local Read Blocks": 0,
    "Local Dirtied Blocks": 0,
    "Local Written Blocks": 0,
    "Temp Read Blocks": 0,
    "Temp Written Blocks": 0,
    "Plans": [
      {
        "Node Type": "Result",
        "Parent Relationship": "Outer",
        "Parallel Aware": false,
        "Async Capable": false,
        "Startup Cost": 0.00,
        "Total Cost": 0.01,
        "Plan Rows": 1,
        "Plan Width": 8,
        "Actual Startup Time": 0.001,
        "Actual Total Time": 0.001,
        "Actual Rows": 1,
        "Actual Loops": 1,
        "Output": ["1", "1"],
        "Shared Hit Blocks": 0,
        "Shared Read Blocks": 0,
        "Shared Dirtied Blocks": 0,
        "Shared Written Blocks": 0,
        "Local Hit Blocks": 0,
        "Local Read Blocks": 0,
        "Local Dirtied Blocks": 0,
        "Local Written Blocks": 0,
        "Temp Read Blocks": 0,
        "Temp Written Blocks": 0
      }
    ]
  },
  "Query Identifier": -7111114701713968825,
  "Planning": {
    "Shared Hit Blocks": 8,
    "Shared Read Blocks": 0,
    "Shared Dirtied Blocks": 0,
    "Shared Written Blocks": 0,
    "Local Hit Blocks": 0,
    "Local Read Blocks": 0,
    "Local Dirtied Blocks": 0,
    "Local Written Blocks": 0,
    "Temp Read Blocks": 0,
    "Temp Written Blocks": 0
  },
  "Planning Time": 0.048,
  "Triggers": [
  ],
  "Execution Time": 0.129
}'),
(34, '###### Plan 34: GROUP BY',
 '{
  "Plan": {
    "Node Type": "Aggregate",
    "Strategy": "Hashed",
    "Partial Mode": "Simple",
    "Parallel Aware": false,
    "Async Capable": false,
    "Startup Cost": 450.00,
    "Total Cost": 583.13,
    "Plan Rows": 13314,
    "Plan Width": 40,
    "Actual Startup Time": 7.783,
    "Actual Total Time": 9.844,
    "Actual Rows": 10000,
    "Actual Loops": 1,
    "Output": ["a", "b", "max(c)"],
    "Group Key": ["tt1.a", "tt1.b"],
    "Planned Partitions": 0,
    "HashAgg Batches": 1,
    "Peak Memory Usage": 1425,
    "Disk Usage": 0,
    "Shared Hit Blocks": 217,
    "Shared Read Blocks": 0,
    "Shared Dirtied Blocks": 0,
    "Shared Written Blocks": 0,
    "Local Hit Blocks": 0,
    "Local Read Blocks": 0,
    "Local Dirtied Blocks": 0,
    "Local Written Blocks": 0,
    "Temp Read Blocks": 0,
    "Temp Written Blocks": 0,
    "Plans": [
      {
        "Node Type": "Seq Scan",
        "Parent Relationship": "Outer",
        "Parallel Aware": false,
        "Async Capable": false,
        "Relation Name": "tt1",
        "Schema": "public",
        "Alias": "tt1",
        "Startup Cost": 0.00,
        "Total Cost": 350.14,
        "Plan Rows": 13314,
        "Plan Width": 12,
        "Actual Startup Time": 0.124,
        "Actual Total Time": 2.776,
        "Actual Rows": 10000,
        "Actual Loops": 1,
        "Output": ["a", "b", "c"],
        "Shared Hit Blocks": 217,
        "Shared Read Blocks": 0,
        "Shared Dirtied Blocks": 0,
        "Shared Written Blocks": 0,
        "Local Hit Blocks": 0,
        "Local Read Blocks": 0,
        "Local Dirtied Blocks": 0,
        "Local Written Blocks": 0,
        "Temp Read Blocks": 0,
        "Temp Written Blocks": 0
      }
    ]
  },
  "Query Identifier": 5213537968251948768,
  "Planning": {
    "Shared Hit Blocks": 4,
    "Shared Read Blocks": 0,
    "Shared Dirtied Blocks": 0,
    "Shared Written Blocks": 0,
    "Local Hit Blocks": 0,
    "Local Read Blocks": 0,
    "Local Dirtied Blocks": 0,
    "Local Written Blocks": 0,
    "Temp Read Blocks": 0,
    "Temp Written Blocks": 0
  },
  "Planning Time": 0.068,
  "Triggers": [
  ],
  "Execution Time": 10.629
}'),
(35, '###### Plan 35: GROUPING SETS',
 '{
  "Plan": {
    "Node Type": "Aggregate",
    "Strategy": "Mixed",
    "Partial Mode": "Simple",
    "Parallel Aware": false,
    "Async Capable": false,
    "Startup Cost": 0.00,
    "Total Cost": 782.86,
    "Plan Rows": 26629,
    "Plan Width": 40,
    "Actual Startup Time": 10.861,
    "Actual Total Time": 14.423,
    "Actual Rows": 20001,
    "Actual Loops": 1,
    "Output": ["a", "b", "max(c)"],
    "Grouping Sets": [
      {
        "Hash Keys": [
          ["tt1.a"]
        ]
      },
      {
        "Hash Keys": [
          ["tt1.b"]
        ]
      },
      {
        "Group Keys": [
          []
        ]
      }
    ],
    "Planned Partitions": 0,
    "HashAgg Batches": 1,
    "Peak Memory Usage": 2841,
    "Disk Usage": 0,
    "Shared Hit Blocks": 217,
    "Shared Read Blocks": 0,
    "Shared Dirtied Blocks": 0,
    "Shared Written Blocks": 0,
    "Local Hit Blocks": 0,
    "Local Read Blocks": 0,
    "Local Dirtied Blocks": 0,
    "Local Written Blocks": 0,
    "Temp Read Blocks": 0,
    "Temp Written Blocks": 0,
    "Plans": [
      {
        "Node Type": "Seq Scan",
        "Parent Relationship": "Outer",
        "Parallel Aware": false,
        "Async Capable": false,
        "Relation Name": "tt1",
        "Schema": "public",
        "Alias": "tt1",
        "Startup Cost": 0.00,
        "Total Cost": 350.14,
        "Plan Rows": 13314,
        "Plan Width": 12,
        "Actual Startup Time": 0.119,
        "Actual Total Time": 1.304,
        "Actual Rows": 10000,
        "Actual Loops": 1,
        "Output": ["a", "b", "c"],
        "Shared Hit Blocks": 217,
        "Shared Read Blocks": 0,
        "Shared Dirtied Blocks": 0,
        "Shared Written Blocks": 0,
        "Local Hit Blocks": 0,
        "Local Read Blocks": 0,
        "Local Dirtied Blocks": 0,
        "Local Written Blocks": 0,
        "Temp Read Blocks": 0,
        "Temp Written Blocks": 0
      }
    ]
  },
  "Query Identifier": -9119124433086544222,
  "Planning": {
    "Shared Hit Blocks": 0,
    "Shared Read Blocks": 0,
    "Shared Dirtied Blocks": 0,
    "Shared Written Blocks": 0,
    "Local Hit Blocks": 0,
    "Local Read Blocks": 0,
    "Local Dirtied Blocks": 0,
    "Local Written Blocks": 0,
    "Temp Read Blocks": 0,
    "Temp Written Blocks": 0
  },
  "Planning Time": 0.071,
  "Triggers": [
  ],
  "Execution Time": 15.922
}'),
(36, '###### Plan 36: Table sample',
 E'{
  "Plan": {
    "Node Type": "Sample Scan",
    "Parallel Aware": false,
    "Async Capable": false,
    "Relation Name": "tt1",
    "Schema": "public",
    "Alias": "tt1",
    "Startup Cost": 0.00,
    "Total Cost": 9.33,
    "Plan Rows": 133,
    "Plan Width": 12,
    "Actual Startup Time": 0.011,
    "Actual Total Time": 0.040,
    "Actual Rows": 185,
    "Actual Loops": 1,
    "Output": ["a", "b", "c"],
    "Sampling Method": "system",
    "Sampling Parameters": ["\'1\'::real"],
    "Repeatable Seed": "\'1\'::double precision",
    "Shared Hit Blocks": 1,
    "Shared Read Blocks": 0,
    "Shared Dirtied Blocks": 0,
    "Shared Written Blocks": 0,
    "Local Hit Blocks": 0,
    "Local Read Blocks": 0,
    "Local Dirtied Blocks": 0,
    "Local Written Blocks": 0,
    "Temp Read Blocks": 0,
    "Temp Written Blocks": 0
  },
  "Query Identifier": 3161085218011102794,
  "Planning": {
    "Shared Hit Blocks": 0,
    "Shared Read Blocks": 0,
    "Shared Dirtied Blocks": 0,
    "Shared Written Blocks": 0,
    "Local Hit Blocks": 0,
    "Local Read Blocks": 0,
    "Local Dirtied Blocks": 0,
    "Local Written Blocks": 0,
    "Temp Read Blocks": 0,
    "Temp Written Blocks": 0
  },
  "Planning Time": 0.038,
  "Triggers": [
  ],
  "Execution Time": 0.093
}'),
(37, '###### Plan 37: Project Set',
 E'{
  "Plan": {
    "Node Type": "Table Function Scan",
    "Parallel Aware": false,
    "Async Capable": false,
    "Table Function Name": "xmltable",
    "Alias": "xmltable",
    "Startup Cost": 0.00,
    "Total Cost": 1.00,
    "Plan Rows": 100,
    "Plan Width": 32,
    "Actual Startup Time": 0.048,
    "Actual Total Time": 0.048,
    "Actual Rows": 2,
    "Actual Loops": 1,
    "Output": ["name"],
    "Table Function Call": "XMLTABLE((\'//towns/town\'::text) PASSING (\'<towns><town><name>Toronto</name></town><town><name>Ottawa</name></town></towns>\'::xml) COLUMNS name text)",
    "Shared Hit Blocks": 0,
    "Shared Read Blocks": 0,
    "Shared Dirtied Blocks": 0,
    "Shared Written Blocks": 0,
    "Local Hit Blocks": 0,
    "Local Read Blocks": 0,
    "Local Dirtied Blocks": 0,
    "Local Written Blocks": 0,
    "Temp Read Blocks": 0,
    "Temp Written Blocks": 0
  },
  "Query Identifier": -6550642607057412222,
  "Planning": {
    "Shared Hit Blocks": 0,
    "Shared Read Blocks": 0,
    "Shared Dirtied Blocks": 0,
    "Shared Written Blocks": 0,
    "Local Hit Blocks": 0,
    "Local Read Blocks": 0,
    "Local Dirtied Blocks": 0,
    "Local Written Blocks": 0,
    "Temp Read Blocks": 0,
    "Temp Written Blocks": 0
  },
  "Planning Time": 0.013,
  "Triggers": [
  ],
  "Execution Time": 0.094
}'),
(38, '###### Plan 38: Incremental Sort',
 '{
  "Plan": {
    "Node Type": "Limit",
    "Parallel Aware": false,
    "Async Capable": false,
    "Startup Cost": 67.40,
    "Total Cost": 68.35,
    "Plan Rows": 31,
    "Plan Width": 8,
    "Actual Startup Time": 0.444,
    "Actual Total Time": 0.448,
    "Actual Rows": 31,
    "Actual Loops": 1,
    "Output": ["(((i.i / 100) + 1))", "((i.i + 1))"],
    "Shared Hit Blocks": 0,
    "Shared Read Blocks": 0,
    "Shared Dirtied Blocks": 0,
    "Shared Written Blocks": 0,
    "Local Hit Blocks": 0,
    "Local Read Blocks": 0,
    "Local Dirtied Blocks": 0,
    "Local Written Blocks": 0,
    "Temp Read Blocks": 0,
    "Temp Written Blocks": 0,
    "Plans": [
      {
        "Node Type": "Incremental Sort",
        "Parent Relationship": "Outer",
        "Parallel Aware": false,
        "Async Capable": false,
        "Startup Cost": 67.40,
        "Total Cost": 97.94,
        "Plan Rows": 1000,
        "Plan Width": 8,
        "Actual Startup Time": 0.443,
        "Actual Total Time": 0.445,
        "Actual Rows": 31,
        "Actual Loops": 1,
        "Output": ["(((i.i / 100) + 1))", "((i.i + 1))"],
        "Sort Key": ["(((i.i / 100) + 1))", "((i.i + 1))"],
        "Presorted Key": ["(((i.i / 100) + 1))"],
        "Full-sort Groups": {
          "Group Count": 1,
          "Sort Methods Used": ["top-N heapsort"],
          "Sort Space Memory": {
            "Average Sort Space Used": 26,
            "Peak Sort Space Used": 26
          }
        },
        "Pre-sorted Groups": {
          "Group Count": 1,
          "Sort Methods Used": ["top-N heapsort"],
          "Sort Space Memory": {
            "Average Sort Space Used": 26,
            "Peak Sort Space Used": 26
          }
        },
        "Shared Hit Blocks": 0,
        "Shared Read Blocks": 0,
        "Shared Dirtied Blocks": 0,
        "Shared Written Blocks": 0,
        "Local Hit Blocks": 0,
        "Local Read Blocks": 0,
        "Local Dirtied Blocks": 0,
        "Local Written Blocks": 0,
        "Temp Read Blocks": 0,
        "Temp Written Blocks": 0,
        "Plans": [
          {
            "Node Type": "Sort",
            "Parent Relationship": "Outer",
            "Parallel Aware": false,
            "Async Capable": false,
            "Startup Cost": 67.33,
            "Total Cost": 69.83,
            "Plan Rows": 1000,
            "Plan Width": 8,
            "Actual Startup Time": 0.396,
            "Actual Total Time": 0.401,
            "Actual Rows": 101,
            "Actual Loops": 1,
            "Output": ["(((i.i / 100) + 1))", "((i.i + 1))"],
            "Sort Key": ["(((i.i / 100) + 1))"],
            "Sort Method": "quicksort",
            "Sort Space Used": 71,
            "Sort Space Type": "Memory",
            "Shared Hit Blocks": 0,
            "Shared Read Blocks": 0,
            "Shared Dirtied Blocks": 0,
            "Shared Written Blocks": 0,
            "Local Hit Blocks": 0,
            "Local Read Blocks": 0,
            "Local Dirtied Blocks": 0,
            "Local Written Blocks": 0,
            "Temp Read Blocks": 0,
            "Temp Written Blocks": 0,
            "Plans": [
              {
                "Node Type": "Function Scan",
                "Parent Relationship": "Outer",
                "Parallel Aware": false,
                "Async Capable": false,
                "Function Name": "generate_series",
                "Schema": "pg_catalog",
                "Alias": "i",
                "Startup Cost": 0.00,
                "Total Cost": 17.50,
                "Plan Rows": 1000,
                "Plan Width": 8,
                "Actual Startup Time": 0.079,
                "Actual Total Time": 0.224,
                "Actual Rows": 1000,
                "Actual Loops": 1,
                "Output": ["((i.i / 100) + 1)", "(i.i + 1)"],
                "Function Call": "generate_series(0, 999)",
                "Shared Hit Blocks": 0,
                "Shared Read Blocks": 0,
                "Shared Dirtied Blocks": 0,
                "Shared Written Blocks": 0,
                "Local Hit Blocks": 0,
                "Local Read Blocks": 0,
                "Local Dirtied Blocks": 0,
                "Local Written Blocks": 0,
                "Temp Read Blocks": 0,
                "Temp Written Blocks": 0
              }
            ]
          }
        ]
      }
    ]
  },
  "Query Identifier": -8727340014176915681,
  "Planning": {
    "Shared Hit Blocks": 0,
    "Shared Read Blocks": 0,
    "Shared Dirtied Blocks": 0,
    "Shared Written Blocks": 0,
    "Local Hit Blocks": 0,
    "Local Read Blocks": 0,
    "Local Dirtied Blocks": 0,
    "Local Written Blocks": 0,
    "Temp Read Blocks": 0,
    "Temp Written Blocks": 0
  },
  "Planning Time": 0.070,
  "Triggers": [
  ],
  "Execution Time": 0.673
}'),
(39, '###### Plan 39: Named Tuplestore Scan',
 '{
  "Plan": {
    "Node Type": "Gather",
    "Parallel Aware": false,
    "Async Capable": false,
    "Startup Cost": 0.00,
    "Total Cost": 21845.68,
    "Plan Rows": 1814322,
    "Plan Width": 36,
    "Actual Startup Time": 0.681,
    "Actual Total Time": 53.684,
    "Actual Rows": 100000,
    "Actual Loops": 1,
    "Output": ["a", "b"],
    "Workers Planned": 2,
    "Workers Launched": 2,
    "Single Copy": false,
    "Shared Hit Blocks": 12170,
    "Shared Read Blocks": 2116,
    "Shared Dirtied Blocks": 2116,
    "Shared Written Blocks": 2117,
    "Local Hit Blocks": 0,
    "Local Read Blocks": 0,
    "Local Dirtied Blocks": 0,
    "Local Written Blocks": 0,
    "Temp Read Blocks": 0,
    "Temp Written Blocks": 0,
    "Plans": [
      {
        "Node Type": "Seq Scan",
        "Parent Relationship": "Outer",
        "Parallel Aware": true,
        "Async Capable": false,
        "Relation Name": "lt1",
        "Schema": "public",
        "Alias": "lt1",
        "Startup Cost": 0.00,
        "Total Cost": 21845.68,
        "Plan Rows": 755968,
        "Plan Width": 36,
        "Actual Startup Time": 0.016,
        "Actual Total Time": 27.314,
        "Actual Rows": 33333,
        "Actual Loops": 3,
        "Output": ["a", "b"],
        "Shared Hit Blocks": 12170,
        "Shared Read Blocks": 2116,
        "Shared Dirtied Blocks": 2116,
        "Shared Written Blocks": 2117,
        "Local Hit Blocks": 0,
        "Local Read Blocks": 0,
        "Local Dirtied Blocks": 0,
        "Local Written Blocks": 0,
        "Temp Read Blocks": 0,
        "Temp Written Blocks": 0,
        "Workers": [
          {
            "Worker Number": 0,
            "Actual Startup Time": 0.020,
            "Actual Total Time": 24.560,
            "Actual Rows": 20804,
            "Actual Loops": 1,
            "Shared Hit Blocks": 2187,
            "Shared Read Blocks": 785,
            "Shared Dirtied Blocks": 785,
            "Shared Written Blocks": 785,
            "Local Hit Blocks": 0,
            "Local Read Blocks": 0,
            "Local Dirtied Blocks": 0,
            "Local Written Blocks": 0,
            "Temp Read Blocks": 0,
            "Temp Written Blocks": 0
          },
          {
            "Worker Number": 1,
            "Actual Startup Time": 0.016,
            "Actual Total Time": 25.090,
            "Actual Rows": 25949,
            "Actual Loops": 1,
            "Shared Hit Blocks": 3056,
            "Shared Read Blocks": 651,
            "Shared Dirtied Blocks": 651,
            "Shared Written Blocks": 651,
            "Local Hit Blocks": 0,
            "Local Read Blocks": 0,
            "Local Dirtied Blocks": 0,
            "Local Written Blocks": 0,
            "Temp Read Blocks": 0,
            "Temp Written Blocks": 0
          }
        ]
      }
    ]
  },
  "Query Identifier": -2777233834602570019,
  "Planning": {
    "Shared Hit Blocks": 6,
    "Shared Read Blocks": 0,
    "Shared Dirtied Blocks": 0,
    "Shared Written Blocks": 0,
    "Local Hit Blocks": 0,
    "Local Read Blocks": 0,
    "Local Dirtied Blocks": 0,
    "Local Written Blocks": 0,
    "Temp Read Blocks": 0,
    "Temp Written Blocks": 0
  },
  "Planning Time": 0.088,
  "Triggers": [
  ],
  "Execution Time": 59.462
}'),
(40, '###### Plan 40: Parallel Index Scan',
 '{
  "Plan": {
    "Node Type": "Gather",
    "Parallel Aware": false,
    "Async Capable": false,
    "Startup Cost": 0.29,
    "Total Cost": 12.05,
    "Plan Rows": 132,
    "Plan Width": 12,
    "Actual Startup Time": 0.359,
    "Actual Total Time": 11.791,
    "Actual Rows": 100,
    "Actual Loops": 1,
    "Output": ["a", "b", "c"],
    "Workers Planned": 1,
    "Workers Launched": 1,
    "Single Copy": false,
    "Shared Hit Blocks": 163,
    "Shared Read Blocks": 0,
    "Shared Dirtied Blocks": 0,
    "Shared Written Blocks": 0,
    "Local Hit Blocks": 0,
    "Local Read Blocks": 0,
    "Local Dirtied Blocks": 0,
    "Local Written Blocks": 0,
    "Temp Read Blocks": 0,
    "Temp Written Blocks": 0,
    "Plans": [
      {
        "Node Type": "Index Scan",
        "Parent Relationship": "Outer",
        "Parallel Aware": true,
        "Async Capable": false,
        "Scan Direction": "Forward",
        "Index Name": "i_tt1",
        "Relation Name": "tt1",
        "Schema": "public",
        "Alias": "tt1",
        "Startup Cost": 0.29,
        "Total Cost": 12.05,
        "Plan Rows": 78,
        "Plan Width": 12,
        "Actual Startup Time": 0.013,
        "Actual Total Time": 0.076,
        "Actual Rows": 50,
        "Actual Loops": 2,
        "Output": ["a", "b", "c"],
        "Index Cond": "(tt1.a < 100)",
        "Rows Removed by Index Recheck": 0,
        "Shared Hit Blocks": 163,
        "Shared Read Blocks": 0,
        "Shared Dirtied Blocks": 0,
        "Shared Written Blocks": 0,
        "Local Hit Blocks": 0,
        "Local Read Blocks": 0,
        "Local Dirtied Blocks": 0,
        "Local Written Blocks": 0,
        "Temp Read Blocks": 0,
        "Temp Written Blocks": 0,
        "Workers": [
          {
            "Worker Number": 0,
            "Actual Startup Time": 0.002,
            "Actual Total Time": 0.002,
            "Actual Rows": 0,
            "Actual Loops": 1,
            "Shared Hit Blocks": 0,
            "Shared Read Blocks": 0,
            "Shared Dirtied Blocks": 0,
            "Shared Written Blocks": 0,
            "Local Hit Blocks": 0,
            "Local Read Blocks": 0,
            "Local Dirtied Blocks": 0,
            "Local Written Blocks": 0,
            "Temp Read Blocks": 0,
            "Temp Written Blocks": 0
          }
        ]
      }
    ]
  },
  "Query Identifier": 5619512539020107938,
  "Planning": {
    "Shared Hit Blocks": 3,
    "Shared Read Blocks": 0,
    "Shared Dirtied Blocks": 0,
    "Shared Written Blocks": 0,
    "Local Hit Blocks": 0,
    "Local Read Blocks": 0,
    "Local Dirtied Blocks": 0,
    "Local Written Blocks": 0,
    "Temp Read Blocks": 0,
    "Temp Written Blocks": 0
  },
  "Planning Time": 0.115,
  "Triggers": [
  ],
  "Execution Time": 11.896
}'),
(41, '###### Plan 41: Gather Merge',
 '{
  "Plan": {
    "Node Type": "Gather Merge",
    "Parallel Aware": false,
    "Async Capable": false,
    "Startup Cost": 617.52,
    "Total Cost": 747.07,
    "Plan Rows": 11096,
    "Plan Width": 4,
    "Actual Startup Time": 10.061,
    "Actual Total Time": 12.403,
    "Actual Rows": 10000,
    "Actual Loops": 1,
    "Output": ["a"],
    "Workers Planned": 2,
    "Workers Launched": 2,
    "Shared Hit Blocks": 329,
    "Shared Read Blocks": 0,
    "Shared Dirtied Blocks": 0,
    "Shared Written Blocks": 0,
    "Local Hit Blocks": 0,
    "Local Read Blocks": 0,
    "Local Dirtied Blocks": 0,
    "Local Written Blocks": 0,
    "Temp Read Blocks": 0,
    "Temp Written Blocks": 0,
    "Plans": [
      {
        "Node Type": "Sort",
        "Parent Relationship": "Outer",
        "Parallel Aware": false,
        "Async Capable": false,
        "Startup Cost": 617.50,
        "Total Cost": 631.37,
        "Plan Rows": 5548,
        "Plan Width": 4,
        "Actual Startup Time": 1.401,
        "Actual Total Time": 1.628,
        "Actual Rows": 3333,
        "Actual Loops": 3,
        "Output": ["a"],
        "Sort Key": ["tt1.a"],
        "Sort Method": "quicksort",
        "Sort Space Used": 385,
        "Sort Space Type": "Memory",
        "Shared Hit Blocks": 329,
        "Shared Read Blocks": 0,
        "Shared Dirtied Blocks": 0,
        "Shared Written Blocks": 0,
        "Local Hit Blocks": 0,
        "Local Read Blocks": 0,
        "Local Dirtied Blocks": 0,
        "Local Written Blocks": 0,
        "Temp Read Blocks": 0,
        "Temp Written Blocks": 0,
        "Workers": [
          {
            "Worker Number": 0,
            "Actual Startup Time": 0.222,
            "Actual Total Time": 0.223,
            "Actual Rows": 0,
            "Actual Loops": 1,
            "Sort Method": "quicksort",
            "Sort Space Used": 25,
            "Sort Space Type": "Memory",
            "Shared Hit Blocks": 56,
            "Shared Read Blocks": 0,
            "Shared Dirtied Blocks": 0,
            "Shared Written Blocks": 0,
            "Local Hit Blocks": 0,
            "Local Read Blocks": 0,
            "Local Dirtied Blocks": 0,
            "Local Written Blocks": 0,
            "Temp Read Blocks": 0,
            "Temp Written Blocks": 0
          },
          {
            "Worker Number": 1,
            "Actual Startup Time": 0.245,
            "Actual Total Time": 0.246,
            "Actual Rows": 0,
            "Actual Loops": 1,
            "Sort Method": "quicksort",
            "Sort Space Used": 25,
            "Sort Space Type": "Memory",
            "Shared Hit Blocks": 56,
            "Shared Read Blocks": 0,
            "Shared Dirtied Blocks": 0,
            "Shared Written Blocks": 0,
            "Local Hit Blocks": 0,
            "Local Read Blocks": 0,
            "Local Dirtied Blocks": 0,
            "Local Written Blocks": 0,
            "Temp Read Blocks": 0,
            "Temp Written Blocks": 0
          }
        ],
        "Plans": [
          {
            "Node Type": "Seq Scan",
            "Parent Relationship": "Outer",
            "Parallel Aware": true,
            "Async Capable": false,
            "Relation Name": "tt1",
            "Schema": "public",
            "Alias": "tt1",
            "Startup Cost": 0.00,
            "Total Cost": 272.48,
            "Plan Rows": 5548,
            "Plan Width": 4,
            "Actual Startup Time": 0.074,
            "Actual Total Time": 0.920,
            "Actual Rows": 3333,
            "Actual Loops": 3,
            "Output": ["a"],
            "Shared Hit Blocks": 217,
            "Shared Read Blocks": 0,
            "Shared Dirtied Blocks": 0,
            "Shared Written Blocks": 0,
            "Local Hit Blocks": 0,
            "Local Read Blocks": 0,
            "Local Dirtied Blocks": 0,
            "Local Written Blocks": 0,
            "Temp Read Blocks": 0,
            "Temp Written Blocks": 0,
            "Workers": [
              {
                "Worker Number": 0,
                "Actual Startup Time": 0.001,
                "Actual Total Time": 0.001,
                "Actual Rows": 0,
                "Actual Loops": 1,
                "Shared Hit Blocks": 0,
                "Shared Read Blocks": 0,
                "Shared Dirtied Blocks": 0,
                "Shared Written Blocks": 0,
                "Local Hit Blocks": 0,
                "Local Read Blocks": 0,
                "Local Dirtied Blocks": 0,
                "Local Written Blocks": 0,
                "Temp Read Blocks": 0,
                "Temp Written Blocks": 0
              },
              {
                "Worker Number": 1,
                "Actual Startup Time": 0.001,
                "Actual Total Time": 0.001,
                "Actual Rows": 0,
                "Actual Loops": 1,
                "Shared Hit Blocks": 0,
                "Shared Read Blocks": 0,
                "Shared Dirtied Blocks": 0,
                "Shared Written Blocks": 0,
                "Local Hit Blocks": 0,
                "Local Read Blocks": 0,
                "Local Dirtied Blocks": 0,
                "Local Written Blocks": 0,
                "Temp Read Blocks": 0,
                "Temp Written Blocks": 0
              }
            ]
          }
        ]
      }
    ]
  },
  "Query Identifier": -9048668626445489755,
  "Planning": {
    "Shared Hit Blocks": 0,
    "Shared Read Blocks": 0,
    "Shared Dirtied Blocks": 0,
    "Shared Written Blocks": 0,
    "Local Hit Blocks": 0,
    "Local Read Blocks": 0,
    "Local Dirtied Blocks": 0,
    "Local Written Blocks": 0,
    "Temp Read Blocks": 0,
    "Temp Written Blocks": 0
  },
  "Planning Time": 0.063,
  "Triggers": [
  ],
  "Execution Time": 13.097
}'));

\pset pager
\set ECHO queries

\echo ###### set shortened JSON
UPDATE plans SET splan = pg_store_plans_shorten(lplan);

\echo ###### tag abbreviation test
SELECT splan FROM plans WHERE id in (-1, -2);

\echo ###### JSON properties round-trip test: !!! This shouldn''''t return a row
SELECT id FROM plans
	where pg_store_plans_jsonplan(splan) <> lplan;

\pset format unaligned
\pset tuples_only on
\pset recordsep '\n\n=======\n'
\echo  ###### format conversion tests
SELECT '### '||'yaml-short       '||title||E'\n'||
  pg_store_plans_yamlplan(splan)
  FROM plans WHERE id BETWEEN 1 AND 3 or id = 1 ORDER BY id;
\echo  ################## 
SELECT '### '||'xml-short        '||title||E'\n'||
  pg_store_plans_xmlplan(splan)
  FROM plans WHERE id BETWEEN 4 AND 6 or id = 1 ORDER BY id;

\echo  ###### text format output test
SELECT '### '||'TEXT-short       '||title||E'\n'||
  pg_store_plans_textplan(splan)
  FROM plans WHERE id >= 0 ORDER BY id;


\echo  ###### long-json-as-a-source test
SELECT '### '||'yaml-long JSON   '||title||E'\n'||
  pg_store_plans_yamlplan(lplan)
  FROM plans WHERE id = 1 ORDER BY id;
\echo  ################## 
SELECT '### '||'xml-long JSON    '||title||E'\n'||
  pg_store_plans_xmlplan(lplan)
  FROM plans WHERE id = 1 ORDER BY id;
\echo  ################## 
SELECT '### '||'text-long JSON   '||title||E'\n'||
  pg_store_plans_xmlplan(lplan)
  FROM plans WHERE id = 1 ORDER BY id;

\echo  ###### chopped-source test
SELECT '### '||'inflate-chopped  '||title||E'\n'||
  pg_store_plans_jsonplan(substring(splan from 1 for char_length(splan) / 3))
  FROM plans WHERE id BETWEEN 16 AND 18 ORDER BY id;
\echo  ################## 
SELECT '### '||'yaml-chopped     '||title||E'\n'||
  pg_store_plans_yamlplan(substring(splan from 1 for char_length(splan) / 3))
  FROM plans WHERE id BETWEEN 19 AND 21 ORDER BY id;
\echo  ################## 
SELECT '### '||'xml-chopped      '||title||E'\n'||
  pg_store_plans_xmlplan(substring(splan from 1 for char_length(splan) / 3))
  FROM plans WHERE id BETWEEN 22 AND 24 ORDER BY id;
\echo  ################## 
SELECT '### '||'text-chopped     '||title||E'\n'||
  pg_store_plans_textplan(substring(splan from 1 for char_length(splan) / 3))
  FROM plans WHERE id BETWEEN 25 AND 27 ORDER BY id;

\echo ###### shorten test
SELECT '### '||'shorten          '||title||E'\n'||
  pg_store_plans_shorten(lplan)
  FROM plans WHERE id = -2 ORDER BY id;
\echo ###### normalize test
SELECT '### '||'normalize        '||title||E'\n'||
  pg_store_plans_normalize(lplan)
  FROM plans ORDER BY id;

